import os
from pathlib import Path

import axipy
def existColorTable(tab: axipy.Raster):
    property_tab=tab.properties
    try:
        name_color_tab=property_tab['metadata']['\\Axioma\\GridColor']
    except:
        name_color_tab=None
    return name_color_tab
def getCurentIndexLayerInMap(layers,tab):
    for i,layer in enumerate(layers):
        if layer.data_object==tab:
            return i
    return -1
def addToLayer(list_map,tab,color_tab):
    layer_color_grid= axipy.Layer.create(color_tab)
    for map in list_map:
        index_layer=getCurentIndexLayerInMap(map.layers,tab)
        if index_layer>=0:
            map.layers.add(layer_color_grid)
            index_color=getCurentIndexLayerInMap(map.layers,color_tab)
            map.layers.move(index_color,index_layer)
            #layer=map.layers[index_layer]

            #layer.data_object=color_tab


def getMapContainTable(tab):
    all_mapview=axipy.gui.view_manager.mapviews
    list_map_for_tab=[]
    for mapview in all_mapview:
        map=mapview.map
        layres=map.layers
        index_layer=getCurentIndexLayerInMap(layres,tab)
        if index_layer>=0:
            list_map_for_tab.append(map)
            continue
    return list_map_for_tab

list_data_obj= axipy.da.data_manager.objects
for tab in list_data_obj:
    if not isinstance(tab, axipy.Raster):
        continue
    color_tab_file=existColorTable(tab)
    if color_tab_file is  None:
        continue
    tab_path=tab.properties['tabFile']
    path_color_table=os.path.join(str(Path(tab_path).parent),color_tab_file)
    list_map=getMapContainTable(tab)
    tab_color=axipy.io.openfile(path_color_table)
    addToLayer(list_map,tab,tab_color)
    jkl=0