from osgeo import ogr, osr

from RasterGridTool.Test.Grid.Contour.tool_smothing.SmothCubic import scipySmoth


def createLineRing(points):
    outRing = ogr.Geometry(ogr.wkbLinearRing)
    for pnt in points:
        outRing.AddPoint(pnt[0],pnt[1])
    return outRing
def createGeometry(type_geometry,points):
    if type_geometry==0:
        pass
    if type_geometry==1:
        ''' Polygon '''
        poly = ogr.Geometry(ogr.wkbPolygon)
        for pnts in points:
            outRing = createLineRing(pnts)
            poly.AddGeometry(outRing)
        return poly
path_source=r"E:\Support\GridTest\point_rf_PHLR_ABS_contourMi.tab"
ds_source=ogr.Open(path_source)
layer = ds_source.GetLayer()
srs_source=layer.GetSpatialRef()
#out_srs= osr.SpatialReference()
#out_srs.ImportFromProj4(srs_source)
path_out="E:\\Support\\GridTest\\point_rf_PHLR_ABS_contour_smoth_cubic.shp"

ogr_ds = ogr.GetDriverByName('ESRI Shapefile').CreateDataSource(path_out)
ogr_lyr = ogr_ds.CreateLayer('contour',srs_source, geom_type=ogr.wkbUnknown)
#ogr_lyr = ogr_ds.CreateLayer('contour',out_srs, geom_type=ogr.wkbLineString)
field_defn = ogr.FieldDefn('ID', ogr.OFTInteger)
ogr_lyr.CreateField(field_defn)
featureDefn = ogr_lyr.GetLayerDefn()

for ft in  layer:
    geom = ft.GetGeometryRef()
    id_val=ft.GetField("ID")
    count_geometry=geom.GetGeometryCount()
    list_points=[]
    for i in range(count_geometry):
        geo_i=geom.GetGeometryRef(i)
        points=geo_i.GetPoints()
        print("Source count:"+str(len(points)))
        Smoothed_obj=scipySmoth(points,5,'quadratic')
        print("Smoth count:"+str(len(Smoothed_obj)))
        list_points.append(Smoothed_obj)
        geo_i=None
    try:
        smoth_geom=createGeometry(1,list_points)
    except:
        smoth_geom=None
    if smoth_geom is not None:
        feature = ogr.Feature(featureDefn)
        feature.SetGeometry(smoth_geom)
        feature.SetField("ID", id_val)
        ogr_lyr.CreateFeature(feature)
    smoth_geom=None
    feature=None
    geom=None
layer=None
ogr_lyr=None
ogr_ds=None
ds_source=None
print("End")