import os
import tempfile

import axipy
from osgeo import ogr, osr, gdal


class tempQueryTab:
    def __init__(self,cs_wkt):
        self.__cs_wkt=cs_wkt
        self.__name_layer="data_grid"
        self.__create(cs_wkt)
    def __create(self,cs_wkt):
        temp_name=next(tempfile._get_candidate_names())
        self.__path_mem_shp=os.path.join("/vsimem/",temp_name+".shp")
        driver_shp=ogr.GetDriverByName('ESRI Shapefile')
        self.__ds = driver_shp.CreateDataSource(self.__path_mem_shp)
        if self.__ds is None:
            return False
        srs =  osr.SpatialReference()
        srs.ImportFromWkt(cs_wkt)
        self.__layer = self.__ds.CreateLayer(self.__name_layer, srs, ogr.wkbUnknown)
        idField = ogr.FieldDefn("id", ogr.OFTInteger)
        self.__layer.CreateField(idField)
        zField = ogr.FieldDefn("z", ogr.OFTReal)
        self.__layer.CreateField(zField)
        self.__featureDefn=self.__layer.GetLayerDefn()
        return True
    def copy(self,axi_table,name_field_z,call_back=None):
        count=axi_table.count()
        for i,ft in enumerate(axi_table.items()):
            if call_back is not None:
                ret_cl=call_back(float(i)/float(count))
                if ret_cl==0:
                    self.__layer=None
                    self.__ds=None
                    return
            if ft is None or ft.geometry is None:
                continue
            ogr_ft=ogr.Feature(self.__featureDefn)
            geometry=ogr.CreateGeometryFromWkb(ft.geometry.wkb)



            ogr_ft.SetGeometry(geometry)
            ogr_ft.SetField("z", ft[name_field_z])
            ogr_ft.SetField("id", i)
            self.__layer.CreateFeature(ogr_ft)
            geometry=None
            ogr_ft=None
        if call_back is not None:
            ret_cl=call_back(100)
        self.__layer=None
        self.__ds=None
        return
    def close(self):
        self.__layer=None
        self.__ds=None
        gdal.Unlink(self.__path_mem_shp)

name_tab='Выборка'
tab_query=axipy.da.data_manager.find(name_tab)
cl_temp=tempQueryTab(tab_query.coordsystem.wkt)
cl_temp.copy(tab_query,"Fitomassa_obshaya")
jkl=0

