import math
from pathlib import Path

from osgeo import gdal, osr

from RasterGridTool.Test.Grid.ui.process_tool.DataSourceContour import MemVectorOgr
from RasterGridTool.Test.Grid.ui.process_tool.addTools import copyOgrLayerToAxiTab, copyOgrLayerToAxiTabSmothing

def getintervals():
    out_intervals=[]
    out_intervals.append({'min':20,"max":40,"mi_style":'Pen (1, 2, 0) Brush (2, 16777215, 16777215)'})
    out_intervals.append({'min':40,"max":60,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':60,"max":80,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':80,"max":100,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':100,"max":120,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':120,"max":140,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':140,"max":160,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':160,"max":180,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':180,"max":200,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':200,"max":220,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':220,"max":240,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':240,"max":260,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':260,"max":280,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    out_intervals.append({'min':280,"max":300,"mi_style":'Pen (1, 2, 0) Brush (2, 16776960, 16777215)'})
    return out_intervals
def callBackProc(i_proc):
    print(i_proc)
path_source="E:\\Support\\GridTest\\point_rf_PHLR_ABS.tif"
ds_source=gdal.Open(path_source)
band_count=ds_source.RasterCount
source_src=ds_source.GetProjectionRef()
out_srs= osr.SpatialReference()
out_srs.ImportFromProj4(source_src)
for id_band in range(band_count):
    curent_band=ds_source.GetRasterBand(id_band+1)
    min_v=curent_band.GetMinimum()
    max_v=curent_band.GetMaximum()
    scale=curent_band.GetScale()
    jkl=0
    noDataValue=curent_band.GetNoDataValue()
count_interval=10
delta=max_v-min_v
step=delta/count_interval
step=20
list_interval=[]
count_interval=math.ceil(delta/step)
dv=int(min_v//step)
new_min=step*dv
for i in range(count_interval+1):
    list_interval.append(i*step+new_min)

path_out="E:\\Support\\GridTest\\testZZ_contourDSmothXZ.tab"
name=Path(path_out).stem
mem_drv=MemVectorOgr(name)
mem_layer=mem_drv.create(name,out_srs)
fix_interval_options="FIXED_LEVELS="
converted_list = [str(element) for element in list_interval]
fix_interval_options = fix_interval_options+",".join(converted_list)
options_countour=[]
options_countour.append(fix_interval_options)
options_countour.append('ID_FIELD=0')
options_countour.append('ELEV_FIELD_MIN=1')
options_countour.append('ELEV_FIELD_MAX=2')
options_countour.append('POLYGONIZE=YES')
options_countour.append('NODATA='+str(noDataValue))
try:
    gdal.ContourGenerateEx(curent_band, mem_layer, options =options_countour)
    #gdal.ContourGenerate(curent_band, 0, 0, list_interval, 0, 0, ogr_lyr, 0, 1)
except Exception as ex:
    jkl=0
#copyOgrLayerToAxiTab(mem_layer,path_out,callBackProc)
copyOgrLayerToAxiTabSmothing(mem_layer,path_out,1.5,getintervals(),callBackProc)
mem_drv.close()
