import os

import axipy
from PySide2 import QtCore
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget
from axipy import Table


def listNumericField(table:Table):
    shema_tab=table.schema
    list_numeric_fields=[]
    for att in shema_tab:
        if att.type_string=='int' or att.type_string=='double':
            list_numeric_fields.append(att.name)
    return list_numeric_fields
class DlgSource(QWidget):
    updateTable = QtCore.Signal(str)
    updateField=QtCore.Signal(str)
    def __init__(self,parent=None):
        super(DlgSource, self).__init__(parent)
        self.__parentWin=parent
        self.load_ui()
        self.window.cmb_tables.currentIndexChanged.connect(self.__change_tab)
        self.__initListTab()
        self.window.cmb_tables.setCurrentIndex(0)
        self.window.cmb_field.currentIndexChanged.connect(self.__change_field)
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "widgetData.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    def __initListTab(self):
        '''
        self.window.cmb_tables.addItem("Test1")
        self.window.cmb_tables.addItem("Test2")
        '''
        tables=axipy.da.data_manager.tables
        for i,tab in enumerate(tables):
            if not tab.is_spatial:
                continue
            list_numeric_field=listNumericField(tab)
            if len(list_numeric_field)==0:
                continue
            self.window.cmb_tables.addItem(tab.name)
            if i==0:
                self.__update_listFields(list_numeric_field)
        self.window.cmb_tables.setCurrentIndex(0)
    def __change_tab(self):
        name_table=self.window.cmb_tables.currentText()
        list_numeric_field=listNumericField(axipy.da.data_manager.find(name_table))
        self.__update_listFields(list_numeric_field)
        self.updateTable.emit(name_table)
    def __change_field(self):
        name_field=self.window.cmb_field.currentText()
        self.updateField.emit(name_field)
    def __update_listFields(self,list_field):
        self.window.cmb_field.clear()
        for field in list_field:
            self.window.cmb_field.addItem(field)
    @property
    def curentTable(self):
        return self.window.cmb_tables.currentText()
    @property
    def curentField(self):
        return self.window.cmb_field.currentText()




