import os
from pathlib import Path

import axipy
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QFileDialog


class WidgetOutFile(QWidget):
    def __init__(self,parent=None):
        super(WidgetOutFile, self).__init__(parent)
        self.__parentWin=parent
        self.load_ui()
        self.window.pb_change_file.clicked.connect(self.__change_file)
        self.__saveFileDlg=QFileDialog()
        #self.__saveFileDlg.setNameFilters(["Gpkg (*.gpkg)","GeoTiff (*.tif)"])
        self.__saveFileDlg.setWindowTitle("Сохранить файл grid")
        #dlg_open.setFileMode(QFileDialog.ExistingFiles)
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "widgetFielGrid.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    def setDefaultFileName(self,path_out):
        self.window.ln_fille_grd.setText(path_out+".tif")
    def __change_file(self):
        folder_out=Path(self.window.ln_fille_grd.text())
        folder_out=str(Path.parent)
        self.__saveFileDlg.setDirectory(folder_out)
        files_select=self.__saveFileDlg.getSaveFileName(axipy.app.mainwindow.qt_object(), 'Сохранить файл grid',self.window.ln_fille_grd.text(), ' GeoTiff (*.tif))')
        #files_select=self.__saveFileDlg.getSaveFileName(axipy.app.mainwindow.qt_object(), 'Сохранить файл grid',self.window.ln_fille_grd.text(), ' Gpkg (*.gpkg);; GeoTiff (*.tif))')
        if files_select[0]=="":
            return
        path_new_file=files_select[0]
        self.window.ln_fille_grd.setText(path_new_file)
    @property
    def nameOutFile(self):
        return self.window.ln_fille_grd.text()


