import os

from PySide2.QtCore import QFile
from PySide2.QtGui import QDoubleValidator, QIntValidator
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget


class DlgIdwNn(QWidget):
    def __init__(self,parent=None):
        self.__parentWin=parent
        super(DlgIdwNn, self).__init__(parent)
        self.load_ui()
        powerValidator=QDoubleValidator()
        powerValidator.setBottom(0.5)
        powerValidator.setTop(4.0)
        dist_search=QDoubleValidator()
        dist_search.setBottom(1)
        self.window.ln_power.setValidator(powerValidator)
        self.window.ln_dist_search.setValidator(dist_search)
        vl_smoth=QDoubleValidator()
        vl_smoth.setBottom(0.0)
        self.window.ln_smoth.setValidator(vl_smoth)

        vl_min_point=QIntValidator()
        vl_min_point.setBottom(0)
        self.window.ln_min_points.setValidator(vl_min_point)
        vl_max_point=QIntValidator()
        vl_max_point.setBottom(1)
        self.window.ln_max_points.setValidator(vl_min_point)

    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "widgetIdwNNParams.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    @property
    def optionsGridCreate(self):
        out_options="invdistnn:"
        str_val_dist_search=self.window.ln_dist_search.text()
        str_power=self.window.ln_power.text()

        out_options=out_options+"power="+str_power+":radius="+str_val_dist_search

        out_options=out_options+":smoothing="+self.window.ln_smoth.text()
        out_options=out_options+":min_points="+self.window.ln_min_points.text()
        out_options=out_options+":max_points="+self.window.ln_max_points.text()
        return out_options
    @property
    def nameMethod(self):
        return "IDWNN"
