import os

from PySide2.QtCore import QFile
from PySide2.QtGui import QDoubleValidator
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget


class DlgNearest(QWidget):
    def __init__(self,parent=None):
        self.__parentWin=parent
        super(DlgNearest, self).__init__(parent)
        self.load_ui()
        dist_search=QDoubleValidator()
        dist_search.setBottom(0.0)
        self.window.ln_dist_search.setValidator(dist_search)
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "widgetNearest.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    @property
    def optionsGridCreate(self):
        out_options="nearest:"
        str_val_dist_search=self.window.ln_dist_search.text()
        #str_power=self.window.ln_power.text()

        out_options=out_options+":radius1="+str_val_dist_search+":radius2="+str_val_dist_search
        out_options=out_options+":angle=0.0"


        return out_options
    @property
    def nameMethod(self):
        return "Nearest"