import multiprocessing
import time
from pathlib import Path

from PySide2 import QtCore
from PySide2.QtCore import QObject, Signal

from osgeo import gdal
class createGrid:

    def process_callback(self,complete, message, user_data):
        #print('progress: {}, message: "{}", unknown {}'.format(complete, message,user_data))
    #if self.__cancelProcess:
    #    return 0
    #self.updateProcess.emit(complete*100)
        self.__parent.window.pr_bar.setValue(complete*100)
        #print(complete*100)
        return 1
    def buildGrid(self,parent_clss,path_out,path_source,name_field,bound_out,param_method,nx,ny,srs_out,type_out=gdal.GDT_Float32,noData=-99999):
        self.__parent=parent_clss
        tab=[0]
        ext_out=str(Path(path_out).suffix)
        out_format='GTiff'
        if ext_out.lower()=='.gpkg':
            out_format="MEM"
            ds_out=gdal.Grid('',path_source,zfield=name_field,outputBounds=bound_out,width=nx,height=ny,outputType=type_out,noData=noData,algorithm=param_method,format=out_format,outputSRS=srs_out,callback=self.process_callback,callback_data = tab)
            if ds_out is None:
                return False
            drv_gpkg=gdal.GetDriverByName( "GPKG" )
            out_ds = drv_gpkg.CreateCopy( path_out, ds_out, 0 )
            if out_ds is not None:
                out_ds=None
                ds_out=None
                return True
        else:
            print(param_method)
            ds_out=gdal.Grid(path_out,path_source,zfield=name_field,outputBounds=bound_out,width=nx,height=ny,outputType=type_out,noData=noData,algorithm=param_method,format=out_format,outputSRS=srs_out,callback=self.process_callback,callback_data = tab)
            if ds_out is not None:
                ds_out=None
                return True
        return False
        #ds_out=gdal.Grid(path_out,path_source,algorithm='invdist:max_points=150:min_points=1:radius=1800',zfield='PHLR_ABS', format='GTiff', width=1712/6, height=819/6,outputType = gdal.GDT_Float32,callback=self.process_callback,callback_data = tab)

class CreateGrid(QObject):
    updateProcess = Signal(float)
    finished = Signal(int)
    def __init__(self,parent_class):
        super(CreateGrid, self).__init__()
        self.__parent=parent_class
    def __process_callback(self,complete, message, user_data):
        #print('progress: {}, message: "{}", unknown {}'.format(complete, message,user_data))
        if self.__cancelProcess:
            return 0
        self.updateProcess.emit(complete*100)
        time.sleep(0.001)
        #self.__parent.window.pr_bar.setValue(complete*100)
        #print(complete*100)
        return 1
    def setCancel(self):
        self.__cancelProcess=True
    def setParam(self,path_out,path_source,name_field,bound_out,param_method,nx,ny,srs_out,type_out=gdal.GDT_Float32,noData=-99999):
        self.__path_out=path_out
        self.__path_source=path_source
        self.__name_field=name_field
        self.__bound_out=bound_out
        self.__param_method=param_method
        self.__nx=nx
        self.__ny=ny
        self.__srs_out=srs_out
        self.__type_out=type_out
        self.__noData=noData
    def run(self):
        self.__tab=[0]
        try:
            self.__parent.disconnect(self.__isCancel)
        except:
            pass
        self.__parent.cancelProcess.connect(self.__isCancel)
        self.__cancelProcess=False
        ds_out=None
        try:
            out_format='GTiff'
            #count_proc=multiprocessing.cpu_count()
            #gdal.SetConfigOption('GDAL_NUM_THREADS', str(count_proc/2))
            ds_out=gdal.Grid(self.__path_out,self.__path_source,zfield=self.__name_field,outputBounds=self.__bound_out,width=self.__nx,height=self.__ny,outputType=self.__type_out,noData=self.__noData,algorithm=self.__param_method,format=out_format,outputSRS=self.__srs_out,callback=self.__process_callback)
        except Exception as ex:
            pass
        #gdal.SetConfigOption('GDAL_NUM_THREADS', 'ALL_CPUS')
        if self.__cancelProcess:
            ds_out==None
            self.updateProcess.emit(0)
            self.finished.emit(0)
        else:
            if ds_out is not None:
                ds_out=None
            self.updateProcess.emit(100)
            self.finished.emit(100)
        if self.__cancelProcess:
            return False
        #self.finished.emit()
        if ds_out is not None:
            ds_out=None
            return True
        return False
    @property
    def pathOutGrid(self):
        return self.__path_out
    def run_old(self,path_out,path_source,name_field,bound_out,param_method,nx,ny,srs_out,type_out=gdal.GDT_Float32,noData=-99999):
        self.__tab=[0]
        try:
            self.__parent.disconnect(self.__isCancel)
        except:
            pass
        self.__parent.cancelProcess.connect(self.__isCancel)
        self.__cancelProcess=False
        try:
            '''
            path_source="E:\\Support\\GridTest\\relief200_gk7.tab"
            path_out="E:\\Support\\GridTest\\relief200_gk7_grd_demo.tif"
            #ds_out=gdal.Grid(path_out,path_source,zfield=name_field,outputBounds=bound_out,width=nx,height=ny,outputType=type_out,noData=noData,algorithm=param_method,callback=self.__process_callback,callback_data = self.__tab)
            ds_out=gdal.Grid(path_out,path_source,algorithm='invdist:max_points=150:min_points=1:radius=1800',zfield='PHLR_ABS', format='GTiff', width=1712/6, height=819/6,outputType = gdal.GDT_Float32,callback=self.__process_callback,callback_data = self.__tab)
            #ds_out=gdal.Grid(path_out,path_source,algorithm='invdist:max_points=150:min_points=1:radius=1800',zfield=name_field, format='GTiff', width=nx, height=ny,outputType = gdal.GDT_Float32,callback=self.__process_callback,callback_data = self.__tab)
            '''
            print(param_method)
            out_format='GTiff'
            ds_out=gdal.Grid(path_out,path_source,zfield=name_field,outputBounds=bound_out,width=nx,height=ny,outputType=type_out,noData=noData,algorithm=param_method,format=out_format,outputSRS=srs_out,callback=self.__process_callback,callback_data = self.__tab)


        except Exception as ex:
            pass
        self.updateProcess.emit(100)
        self.finished.emit()
        #self.finished.emit()
        if ds_out is not None:
            ds_out=None
            return True
        return False


    def __isCancel(self):
        self.__cancelProcess=True