import os.path
from pathlib import Path

from axipy import provider_manager

from RasterGridTool import RasterSource
from RasterGridTool.toolprocessing.grid_io.ColorPaletts import ColorsPalett
from RasterGridTool.toolprocessing.grid_io.VrtGridColor import VrtXml
from RasterGridTool.toolprocessing.grid_io.utils import MiTabFileRaster
from RasterGridTool.toolprocessing.ui.addTools.mapTool import addRasterTabLayerUpTab
from RasterGridTool.toolprocessing.ui.addTools.utils import getListGridTab, findGridTabByName

name_tab='Elevation_gtif'
raster_tab=findGridTabByName(name_tab)
if raster_tab is not None:
    path_tab=raster_tab.properties['tabFile']
    raster_path=raster_tab.properties['tabFileData']['linkFile']
    cls_colors=ColorsPalett()
    name_pal='DEM_Print'
    color_table=cls_colors.getColorTable(name_pal)
    gd_grid=RasterSource()
    isOk=gd_grid.OpenRead(raster_path)
    name_vrt=VrtXml.createVrtColor(gd_grid,color_table,1,None)
    gd_grid.close()
    cls_tab=MiTabFileRaster.createClass(path_tab)
    cls_tab.setNewRaster(name_vrt)
    path_base=Path(path_tab).parent
    name_source=Path(path_tab).stem
    path_vrt_tab=os.path.join(path_base,name_source+"_vrt.tab")
    cls_tab.saveAs(path_vrt_tab)
    tab_vrt=provider_manager.openfile(path_vrt_tab)
    addRasterTabLayerUpTab(raster_tab,tab_vrt)

