import axipy
from axipy import provider_manager, Layer


def getTableByName(name):
    def isRaster(obj):
        if not isinstance(obj, axipy.Raster):
            return False
        return True
    rasters = list(filter(isRaster, axipy.da.data_manager.objects))
    if rasters is None or len(rasters)==0:
        return None
    for tab in rasters:
        if tab.name==name:
            return tab
    return None
def getCurentIndexLayerInMap(layers,tab):
    for i,layer in enumerate(layers):
        if layer.data_object==tab:
            return i
    return -1
def getMapContainTable(tab):
    all_mapview=axipy.gui.view_manager.mapviews
    list_map_for_tab=[]
    for mapview in all_mapview:
        map=mapview.map
        layres=map.layers
        index_layer=getCurentIndexLayerInMap(layres,tab)
        if index_layer>=0:
            list_map_for_tab.append(map)
            continue
    return list_map_for_tab
def reOpenRaster(tab_raster):
    name_old=tab_raster.name
    path_tab=tab_raster.properties['tabFile']
    #tab_raster.close()
    axipy.da.data_manager.remove(tab_raster)
    tab_raster=None
    tab_temp=getTableByName(name_old)
    if tab_temp is not None:
        tab_temp.close()
        tab_temp=None

    tab_raster=provider_manager.openfile(path_tab)
    tab_raster.name=name_old
    return tab_raster
def reloadRasterTab(tab_raster):
    list_map_raster=getMapContainTable(tab_raster)

    if len(list_map_raster)==0:
        reOpenRaster(tab_raster)
        return
    list_map_and_layer=[]
    for map in list_map_raster:
        index_layer=getCurentIndexLayerInMap(map.layers,tab_raster)
        if index_layer>=0:
            list_map_and_layer.append({'map':map,"id_layer":index_layer})
    tab_raster=reOpenRaster(tab_raster)

    new_raster_layer= Layer.create(tab_raster)
    for map_index in list_map_and_layer:
        map=map_index['map']
        index=map_index['id_layer']
        map.layers.add(new_raster_layer)
        index_new=getCurentIndexLayerInMap(map.layers,tab_raster)
        if index_new>=index:
            map.layers.move(index_new,index)
            jkl=0

name_tab='Elevation_gtif_color'
tab_raster=getTableByName(name_tab)
if tab_raster is not None:
    reloadRasterTab(tab_raster)