from pathlib import Path

import vtk
from osgeo import gdal

from RasterGridTool.Vtk.ui.process.gridToTin.rowsToTriangle import gridToTin
from RasterGridTool.Vtk.ui.process.memGrid import MemGrid
from RasterGridTool.toolprocessing.grid_io.VrtGridColorNewPalette import VrtXml


def main():
    path_grid = r'E:\Support\GridTest\gel_relf_ptp_axi_grid50.gpkg'
    path_stl = r'E:\Support\GridTest\gel_relf_ptp_axi_grid50_dem.stl'
    # path_grid=r'E:\Support\GridTest\gel_relf_ptp_axi_grid_200.gpkg'
    # self.__vrt_file = VrtXml(self.__raster_path)
    path_grid = r'E:\Support\GridTest\gel_relf_ptp_axi_grid_color.vrt'
    #path_grid = r'E:\Support\GridTest\gel_relf_ptp_axi_grid_200_color.vrt'
    vrt_file = VrtXml(path_grid)
    base_raster_list = vrt_file.baseRaster
    name_base = base_raster_list[0]['file']
    path_base_raster = str(Path(path_grid).parent.joinpath(name_base))
    colorTab = vrt_file.colorMap()
    ds = gdal.Open(path_base_raster)
    band_grd = ds.GetRasterBand(1)
    memGrid = MemGrid()

    memGrid.Load(ds)
    colorTab.setZminZmax(memGrid.Zmin,memGrid.Zmax)
    tinPolyData = gridToTin(memGrid, colorTab)
    #tinPolyData = gridToTin(memGrid, None)
    meshMapper = vtk.vtkPolyDataMapper()
    meshMapper.AddInputDataObject(tinPolyData)

    meshActor = vtk.vtkActor()
    meshActor.SetMapper(meshMapper)
    meshActor.GetProperty().SetEdgeColor(0, 0, 1)
    meshActor.GetProperty().SetInterpolationToFlat()
    # meshActor.GetProperty().SetRepresentationToWireframe()



    renderer = vtk.vtkRenderer()
    renderWindow = vtk.vtkRenderWindow()
    renderWindow.AddRenderer(renderer)
    renderWindowInteractor = vtk.vtkRenderWindowInteractor()
    renderWindowInteractor.SetRenderWindow(renderWindow)
    renderer.AddActor(meshActor)

    renderer.SetBackground(.3, .6, .3)

    renderWindowInteractor.Initialize()
    renderWindow.Render()
    renderWindowInteractor.Start()
if __name__ == '__main__':
    main()