import axipy
import vtk
from axipy import Table, Pnt, Geometry


def getPointFromPoint(geo):
    return [Pnt(geo.x,geo.y)]
def getPointFromPolygon(geo):
    points=[]
    points.extend(geo.points)
    if geo.type==axipy.GeometryType.LineString :
        return points
    del points[-1]
    for geo_hole in geo.holes:
        points.extend(geo_hole)
        del points[-1]
    return points
def getPointFromLine(geo):
    return [geo.begin,geo.end]
def getPointsCollection(geo:Geometry):
    points=[]
    for g in geo:
        pts_g=getPoints(g)
        if pts_g is not None:
            points.extend(pts_g)
    if len(points)==0:
        return None
    return points
def getPoints(geo:Geometry):
    points_source=None
    if geo.type == axipy.GeometryType.Point:
        return getPointFromPoint(geo)
    if geo.type == axipy.GeometryType.MultiPoint:
        points_source = getPointsCollection(geo)
    elif geo.type == axipy.GeometryType.Polygon:
        points_source = getPointFromPolygon(geo)
    elif geo.type == axipy.GeometryType.Line:
        points_source = getPointFromLine(geo)
    elif geo.type == axipy.GeometryType.LineString:
        points_source = getPointFromPolygon(geo)
    elif geo.type == axipy.GeometryType.LineString:
        points_source = getPointFromPolygon(geo)
    elif geo.type == axipy.GeometryType.MultiLineString:
        points_source = getPointsCollection(geo)
    elif geo.type == axipy.GeometryType.MultiPolygon:
        points_source = getPointsCollection(geo)
    elif geo.type == axipy.GeometryType.GeometryCollection:
        points_source = getPointsCollection(geo)
    return points_source
def getVtkPoints(table_source:Table,name_fild_z)->vtk.vtkPoints:
    count_feature=table_source.count()
    points = vtk.vtkPoints()
    for i,ft in enumerate(table_source.items()):
        geo=ft.geometry
        if geo is None:
            continue
        value=ft[name_fild_z]
        points_source=None
        points_source=getPoints(geo)
        if points_source is None:
            continue
        for pnt in points_source:
            points.InsertNextPoint(pnt.x, pnt.y, value)
    return points




'''
path_source=r"E:\Support\GridTest\collectionObj.tab"
name_tab='collectionObj'
table=axipy.data_manager.find(name_tab)
vtkPoints=getVtkPoints(table,"ID")
'''