#import gdal
#import gdal
import numpy as np
import osgeo
from osgeo import *
from osgeo import gdal
from osgeo.gdalconst import GCI_RedBand


def array2raster(newRasterfn,rasterOrigin,pixelWidth,pixelHeight,array):

    cols = array.shape[1]
    rows = array.shape[0]
    originX = rasterOrigin[0]
    originY = rasterOrigin[1]

    driver = gdal.GetDriverByName('GTiff')
    #driver = gdal.GetDriverByName('PNG')
    #driver = gdal.GetDriverByName('GS7BG')
    #driver = gdal.GetDriverByName('GPKG')
    outRaster = driver.Create(newRasterfn, cols, rows, 1,gdal.GDT_Byte)
    #outRaster = driver.Create(newRasterfn, cols, rows, 1, gdal.GDT_Float32)
   # outRaster = driver.Create(newRasterfn, cols, rows, 1, gdal.GDT_UInt16)
    outRaster.SetGeoTransform((originX, pixelWidth, 0, originY, 0, pixelHeight))
    outband = outRaster.GetRasterBand(1)
    outband.WriteArray(array)
    outRasterSRS = gdal.osr.SpatialReference()
    outRasterSRS.ImportFromEPSG(3857)
    outRaster.SetProjection(outRasterSRS.ExportToWkt())
 #   outRaster.AddBand(gdal.GDT_UInt16)
 #   outRaster.AddBand(gdal.GDT_UInt16 )
 #   outRaster.AddBand(gdal.GDT_UInt16 )
 #   coubt_band=outRaster.RasterCount
 #   outband_r = outRaster.GetRasterBand(2)
 #   outband_r.SetRasterColorInterpretation(GCI_RedBand)
    start_color = (255,255,0,0)
    end_color = (255,0,255,0)
    ct = gdal.ColorTable()
    ct.CreateColorRamp(int(0),start_color,int(1),end_color)
    #outband.SetColorTable(ct)
    outband.FlushCache()

    #outband=None
    #outRaster=None
def main(newRasterfn,rasterOrigin,pixelWidth,pixelHeight,array):
    reversed_arr = array[::-1] # reverse array so the tif looks like the array
    array2raster(newRasterfn,rasterOrigin,pixelWidth,pixelHeight,reversed_arr) # convert array to raster

nx=10
ny=10
rasterOrigin=(4132998.5,7548651.0)
newRasterfn = 'c:/Support/testGolden2.gpkg'
newRasterfn = 'c:/Support/testGolden2.tif'
#newRasterfn = 'c:/Support/testGolden4.png'
array = np.array([[ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
                      [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
                      [ 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1],
                      [ 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1],
                      [ 1, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1],
                      [ 1, 0, 1, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1],
                      [ 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1],
                      [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
                      [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
                      [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]])
main(newRasterfn,rasterOrigin,nx,ny,array)

