import axioma
import axipy
import vtk
from PyQt5 import QtCore
from PyQt5.QtWidgets import QApplication, QMainWindow, QWidget, QGridLayout
#from PySide2 import QtCore
#from vtk.qt.QVTKRenderWindowInteractor import QVTKRenderWindowInteractor
import sys

from vtkmodules.qt.QVTKRenderWindowInteractor import QVTKRenderWindowInteractor


class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(603, 553)
        self.centralWidget =QWidget(MainWindow)
        self.gridlayout = QGridLayout(self.centralWidget)
        self.vtkWidget = QVTKRenderWindowInteractor(self.centralWidget)
        self.gridlayout.addWidget(self.vtkWidget, 0, 0, 1, 1)
        MainWindow.setCentralWidget(self.centralWidget)
class SimpleView(QMainWindow):

    def __init__(self, parent = None):
        QMainWindow.__init__(self, parent)
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        self.ren = vtk.vtkRenderer()
        self.ui.vtkWidget.GetRenderWindow().AddRenderer(self.ren)
        self.iren = self.ui.vtkWidget.GetRenderWindow().GetInteractor()
        data_dir = "E:/Download/vtk/"


        tss = vtk.vtkTexturedSphereSource()
        tss.SetThetaResolution(18)
        tss.SetPhiResolution(9)
        earthMapper = vtk.vtkPolyDataMapper()
        earthMapper.SetInputConnection(tss.GetOutputPort())
        earthActor = vtk.vtkActor()
        earthActor.SetMapper(earthMapper)


        # Create the background image
      #  reader = vtk.vtkPNMReader()
        reader =vtk.vtkJPEGReader()
        #reader.SetFileName(data_dir + "earth.ppm")
        reader.SetFileName("E:/Download/Image_vtk/NE2_bathymetry.jpg")
        reader.Update()
        atext = vtk.vtkTexture()
        atext.SetInputConnection(reader.GetOutputPort())
        atext.InterpolateOn()
        earthActor.SetTexture(atext)
        es = vtk.vtkEarthSource()
        es.SetRadius(0.501)
        es.SetOnRatio(4)
        earth2Mapper = vtk.vtkPolyDataMapper()
        earth2Mapper.SetInputConnection(es.GetOutputPort())

       # mapper.SetInputConnection(reader.GetOutput())
       # mapper.SetInputData()

        # Create an actor
        actor = vtk.vtkActor()

        actor.SetMapper(earth2Mapper)
        #actor.SetTexture(atext)
        self.ren.AddActor(earthActor)
        self.ren.AddActor(actor)

#window = SimpleView(axioma.app.mainWindow)
window = SimpleView(axipy.app.mainwindow.qt_object())
window.setWindowTitle("AxiomaVtk")
window.setWindowModality(QtCore.Qt.ApplicationModal)
window.show()
window.iren.Initialize()