import vtk
from PyQt5 import QtCore
from PyQt5.QtWidgets import QApplication, QMainWindow, QWidget, QGridLayout

from vtkmodules.qt.QVTKRenderWindowInteractor import QVTKRenderWindowInteractor
from vtkmodules.vtkInteractionWidgets import vtkCameraOrientationWidget


class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(603, 553)
        self.centralWidget =QWidget(MainWindow)
        self.gridlayout = QGridLayout(self.centralWidget)
        self.vtkWidget = QVTKRenderWindowInteractor(self.centralWidget)
        self.gridlayout.addWidget(self.vtkWidget, 0, 0, 1, 1)
        MainWindow.setCentralWidget(self.centralWidget)
class SimpleViewActors(QMainWindow):
    closeWindows =QtCore.pyqtSignal()
    def __init__(self, actrors,parent = None):
        self.__isClose=False
        QMainWindow.__init__(self, parent)
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        self.ren = vtk.vtkRenderer()
        #self.ren.SetBackground(0.1, 0.2, 0.4)
        self.ui.vtkWidget.GetRenderWindow().AddRenderer(self.ren)
        self.iren = self.ui.vtkWidget.GetRenderWindow().GetInteractor()
        for actor in actrors:
            self.ren.AddActor(actor)
        '''
        cam_orient_manipulator = vtkCameraOrientationWidget()
        cam_orient_manipulator.SetParentRenderer(self.ren )
        # Enable the widget.
        cam_orient_manipulator.On()
        '''
    def setBackground(self,rgbf,update=False):
        self.ren.SetBackground(rgbf[0],rgbf[1], rgbf[2])
        if update:
            self.ui.vtkWidget.GetRenderWindow().Render()
    def updateActorColor(self,rgbf,id_actor=0):
        actors=self.ren.GetActors()
        jkl=0
        actors.GetItemAsObject(0).GetProperty().SetColor(rgbf[0], rgbf[1], rgbf[2])
        self.ui.vtkWidget.GetRenderWindow().Render()
    def closeEvent(self, event):
        self.__isClose=True
        event.accept()
        self.closeWindows.emit()
    @property
    def isCloseWin(self):
        return self.__isClose

