import os

import axipy
from PySide2.QtGui import QIcon
from axipy import view_manager

from RasterGridTool.Vtk.ui.DlgFormTinVtk import FormVtkTin
from RasterGridTool.Vtk.ui.FormTinToGrid import FormTinToGrid
from RasterGridTool.toolprocessing.Utils.Observer import factoryObserverTabForGrid
from RasterGridTool.toolprocessing.Utils.helper_observer import factoryObserverTabOneNumberField
from RasterGridTool.toolprocessing.ui.docWidget import AxiDocWidget, addDoc, DelDocWidget


class VtkCreateTin:
    __name='Создание Tin'
    __name_observer='CountTableForGrid'
    __name_observer = 'VectorOneNumber'
    __type_observer="catalog_vector_for_grid"
    __form_tool=None
    __docWidget=None
    #__def_name_group="Создание тепловой карты"
    __def_name_group="3D"
    def __init__(self,parentPlugin):
        self._initTool(parentPlugin)

    def _initTool(self, parentPlugin):
        #self.__observer = factoryObserverTabForGrid(self.__name_observer)
        self.__observer = factoryObserverTabOneNumberField(self.__name_observer)
        self.__observer.changed.connect(self.__changeValueObserver)
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'tin48.png')
        try:
            self.__action = parentPlugin.create_action(self.__name, icon=local_file_icon,
                                                       on_click=self.__run_create_tin, enable_on=self.__name_observer)
        except Exception as ex:
            jkl = 0
        return

    @property
    def name(self):
        return self.__name

    @property
    def name_group(self):
        return self.__def_name_group

    @property
    def action(self):
        return self.__action

    @property
    def nameObserver(self):
        return self.__name_observer

    @property
    def typeObserver(self):
        return self.__type_observer

    @property
    def docWidget(self):
        return self.__docWidget

    @property
    def form(self):
        return self.__form_tool

    def __run_create_tin(self):
        if self.__form_tool is None:
            self.__form_tool =  FormVtkTin(view_manager.global_parent)
            #self.__observer.addChildrenWidget("CreateTin", self.__form_tool)
        if self.__docWidget is None:
            mainwindowAxi = view_manager.global_parent
            self.__docWidget = AxiDocWidget(self.__form_tool.widget, "CreateTin", self.__name, QIcon(), mainwindowAxi)
            #addDoc(mainwindowAxi, self.__docWidget)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
    def __changeValueObserver(self):
        status=self.__observer.value
        if status ==False:
            if self.__docWidget is not None:
                DelDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
                #self.__observer.removeChildrenWidget("CreateGrid")
                return
        if status:
            if self.__docWidget is not None:

                self.__form_tool= FormVtkTin(view_manager.global_parent)
                #self.__observer.addChildrenWidget("CreateTin",self.__form_tool)
                self.__docWidget=AxiDocWidget(self.__form_tool.widget,"CreateTin",self.__name,QIcon(),view_manager.global_parent)
                addDoc(view_manager.global_parent,self.__docWidget)