import numpy as np
from PySide2.QtCore import QObject


class RowCalcGrid(QObject):
    def __init__(self,prams_grid,zmin,zmax,tin_source):
        super().__init__()
        self.__params_grid=prams_grid
        self.__zmin=zmin
        self.__zmax=zmax
        self.__tin=tin_source
    @property
    def Ny(self):
        return self.__params_grid['ny']
    def calcRow(self,id_row):
        self.__array_row = np.full(self.__params_grid['nx'],self.__params_grid['nodata'], dtype=np.float32)
        ymin=self.__params_grid['ymin']
        xmin=self.__params_grid['xmin']
        y=ymin+id_row*self.__params_grid['stepy']
        for i in range(self.__params_grid['nx']):
            x=xmin+i*self.__params_grid['stepx']
            pointIntersect=self.__tin.getInersection([x,y,self.__zmin],[x,y,self.__zmax])
            if pointIntersect is None:
                continue
            self.__array_row[i]=pointIntersect[2]
        return self.__array_row



