import vtk
import qtpy.QtWidgets
import vtk
#from PyQt5 import QtCore
#from PyQt5.QtWidgets import QApplication, QMainWindow, QWidget, QGridLayout
from qtpy import QtCore
from qtpy.QtCore import Signal
from qtpy.QtWidgets import QMainWindow, QWidget
from vtkmodules.qt.QVTKRenderWindowInteractor import QVTKRenderWindowInteractor
from vtkmodules.vtkInteractionWidgets import vtkCameraOrientationWidget


from vtkmodules.qt.QVTKRenderWindowInteractor import QVTKRenderWindowInteractor


class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(603, 553)
        self.centralWidget =QWidget(MainWindow)
        self.gridlayout = qtpy.QtWidgets.QGridLayout(self.centralWidget)
        self.vtkWidget = QVTKRenderWindowInteractor(self.centralWidget)
        self.gridlayout.addWidget(self.vtkWidget, 0, 0, 1, 1)
        MainWindow.setCentralWidget(self.centralWidget)
class SimpleViewActors(QMainWindow):
    closeWindows =Signal()
    def __init__(self, actrors,parent = None):
        self.__isClose=False
        QMainWindow.__init__(self, parent)
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        self.ren = vtk.vtkRenderer()
        #self.ren.SetBackground(0.1, 0.2, 0.4)
        self.ui.vtkWidget.GetRenderWindow().AddRenderer(self.ren)
        self.iren = self.ui.vtkWidget.GetRenderWindow().GetInteractor()
        for actor in actrors:
            if actor is not None:
                self.ren.AddActor(actor)
    def setBackground(self,rgbf,update=False):
        self.ren.SetBackground(rgbf[0],rgbf[1], rgbf[2])
        if update:
            self.ui.vtkWidget.GetRenderWindow().Render()
    def setVisibility(self,visiblity,id=None):
        actors = self.ren.GetActors()
        count_actors = actors.GetNumberOfItems()
        if id is None:
            for i in range(count_actors):
                actors.GetItemAsObject(i).GetProperty().SetVisibility(visiblity)
            self.ren.UpdateGeometry()
            return
        actors.GetItemAsObject(id).SetVisibility(visiblity)
        #self.ren.UpdateGeometry()
        #self.ren.Render()

    def updateActorColor(self,rgbf,id_actor=0):
        actors=self.ren.GetActors()

        actors.GetItemAsObject(0).GetProperty().SetColor(rgbf[0], rgbf[1], rgbf[2])
        self.ui.vtkWidget.GetRenderWindow().Render()
    def updateActorWireframe(self,on,id=None):
        actors = self.ren.GetActors()
        count_actors=actors.GetNumberOfItems()
        if id is None:
            for i in range(count_actors):
                if on:
                    actors.GetItemAsObject(i).GetProperty().SetRepresentationToWireframe()
                else:
                    actors.GetItemAsObject(i).GetProperty().SetRepresentationToSurface()
        self.ui.vtkWidget.GetRenderWindow().Render()
    def closeEvent(self, event):
        self.__isClose=True
        event.accept()
        self.closeWindows.emit()
    @property
    def isCloseWin(self):
        return self.__isClose

