import vtk
from vtkmodules.vtkIOGeometry import vtkSTLReader

from RasterGridTool.Vtk.ui.process.helper import _update_alg


class VtkTin:
    def load(self,path_file,call_back=None):
        reader = vtkSTLReader()
        reader.SetFileName(path_file)
        if call_back is not None:
            _update_alg(reader, call_back)
        else:
            reader.Update()
        self.__polydata = reader.GetOutput()
        self.__bound=self.__polydata.GetBounds()
        self.__cellLocator = vtk.vtkCellLocator()
        self.__cellLocator.SetDataSet(self.__polydata)
        self.__cellLocator.BuildLocator()
    @property
    def bound(self):
        return self.__bound
    def getInersection(self,pt1,pt2,tollerance= 1e-8):
        pIntSect = [0.0, 0.0, 0.0]
        pcoords = [0.0, 0.0, 0.0]
        t = vtk.mutable(0)
        sub_id = vtk.mutable(0)
        isValid=self.__cellLocator.IntersectWithLine(pt1, pt2, tollerance, t, pIntSect, pcoords, sub_id)
        if isValid==1:
            return pIntSect
        return None