import numpy as np
import vtk
import time

def twoRowToPsevdoTriangle(row_0,row_1,id_row,noData):
    nx=row_0.shape[0]
    psevdo_triangls=[]
    for i in range(nx-1):
        id0=(i,id_row,)
        id1=(i+1,id_row,)
        id2=(i+1,id_row+1,)
        id3 = (i , id_row + 1,)
        p0=row_0[i]
        p1=row_0[i+1]
        p2=row_1[i+1]
        p3=row_1[i]
        if p0==noData and p1==noData and p2==noData and p3==noData:

            continue
        if p0!=noData and p1!=noData and p2!=noData and p3!=noData:
            ''' все четыре точки валидны'''
            #psevdo_triangls.append([id0,id1,id2])
            #psevdo_triangls.append([id3, id1, id2])
            psevdo_triangls.append([id2,id1,id0])
            psevdo_triangls.append([id2, id0, id3])
            continue
        if p0==noData and (p1!=noData and p2!=noData and p3!=noData):
            psevdo_triangls.append([id2, id1, id3])
            continue
        if p1==noData and (p0!=noData and p2!=noData and p3!=noData):
            #psevdo_triangls.append([id0, id2, id3])
            psevdo_triangls.append([id0, id3, id2])
            continue
        if p2==noData and (p0!=noData and p1!=noData and p3!=noData):
            #psevdo_triangls.append([id3, id0, id1])
            psevdo_triangls.append([id1, id0, id3])
            continue
        if p3==noData and (p0!=noData and p1!=noData and p2!=noData):
            #psevdo_triangls.append([id0, id1, id2])
            psevdo_triangls.append([id2, id1, id0])
            continue
        jkl=0
    if len(psevdo_triangls)==0:
        return None
    return psevdo_triangls
def gridToTin(grid_cls,colorTable=None,call_back_progres=None):
    grid_index_point=np.full((grid_cls.Ny,grid_cls.Nx),-1,dtype=np.int_)
    points = vtk.vtkPoints()
    triangles = vtk.vtkCellArray()
    time_tin=None
    time_next_proc=None
    isCancel=False
    colors=None
    if colorTable is not None:
        colors = vtk.vtkUnsignedCharArray()
        colors.SetName('Colors')
        colors.SetNumberOfComponents(3)
    for j in range(grid_cls.Ny-1):
        if call_back_progres is not None:
            is_cancel = call_back_progres(j / grid_cls.Ny)
            if is_cancel == 0:
                # logging.debug(("send send cancel"))
                isCancel=True
                break
        row_0 = grid_cls.getRow(j)
        row_1=grid_cls.getRow(j+1)
        ts_tin_row=time.time()
        psevdo_triangle=twoRowToPsevdoTriangle(row_0,row_1,j,grid_cls.NoData)
        ts_tin_end=time.time()
        if time_tin is None:
            time_tin=ts_tin_end-ts_tin_row
        else:
            time_tin = time_tin+(ts_tin_end - ts_tin_row)
        if psevdo_triangle is None:
            continue
        time_start_next=time.time()
        for ps_tri in psevdo_triangle:
            ''' vertex цикл'''
            triangle = vtk.vtkTriangle()
            for id_vertex in range(3):
                vertex=ps_tri[id_vertex]
                id_point= grid_index_point[vertex[1]][vertex[0]]
                if id_point<0:
                    ''' new point'''
                    x_geo,y_geo=grid_cls.getGeoXY(vertex[0],vertex[1])
                    z=grid_cls.Z(vertex[0],vertex[1])
                    if colorTable is not None:
                        qt_color = colorTable.getColor(z)
                        color_rgb = [qt_color.red(),qt_color.green(), qt_color.blue()]
                        #colors.InsertNextTupleValue(color_rgb)
                        colors.InsertNextTuple(color_rgb)
                    id_point=points.InsertNextPoint(x_geo,y_geo,z)
                    grid_index_point[vertex[1]][vertex[0]]=id_point
                else:
                    jkl=0
                triangle.GetPointIds().SetId(id_vertex, id_point)
            triangles.InsertNextCell(triangle)
        time_end_next = time.time()
        if time_next_proc is None:
            time_next_proc=time_end_next-time_start_next
        else:
            time_next_proc = time_next_proc+(time_end_next - time_start_next)
    if isCancel:
        return None,None
    points.Modified()
    print("getTinTime")
    print(time_tin)
    print("getNextTime")
    print(time_next_proc)
    bound_tin = points.GetBounds()
    all_points = points.GetNumberOfPoints()
    bounds_pt = points.ComputeBounds()
    # polydata object
    trianglePolyData = vtk.vtkPolyData()
    trianglePolyData.SetPoints(points)
    trianglePolyData.SetPolys(triangles)
    #if colorTable is not None:
        #trianglePolyData.GetPointData().SetScalars(colors)
    trianglePolyData.Modified()

    bounds_poly = trianglePolyData.ComputeBounds()
    return trianglePolyData,colors








