import os

import axipy
from axipy import AxiomaPlugin, state_manager

#from MergeData import DelDocWidget
from .toolprocessing import ColorPalette
from .toolprocessing.CalcVariogram import CalcVariogram
from .toolprocessing.ColorPalette import ColorPaletteTools
from .toolprocessing.CreaterGrid import CreateGrid
from .toolprocessing.Utils.tools import existInList, findObserver
from .toolprocessing.grid_io.GdalSource import RasterSource
from .toolprocessing.ui.docWidget import DelDocWidget


class Plugin(AxiomaPlugin):
    def load(self):
        self.__list_cls_action=[]
        self.__observer_data_catalog=None
        #name_observer="CountTableGrid"
        cls_colorPalette=ColorPaletteTools.factory(self)
        if cls_colorPalette is not None:
            self.__list_cls_action.append(cls_colorPalette)

        cls_createGrid=CreateGrid(self)
        if cls_createGrid is not None:
            self.__list_cls_action.append(cls_createGrid)

        cls_calcVario=CalcVariogram(self)
        self.__list_cls_action.append(cls_calcVario)

        for cls_action in self.__list_cls_action:
            if cls_action.typeObserver=='catalog':
                name_observer=cls_action.nameObserver
                self.__observer_data_catalog=findObserver(name_observer)

        position = self.get_position('Растер Грид', 'Инструменты')
        for cls_action in self.__list_cls_action:
            position.add(cls_action.action,size=2)
        axipy.da.data_manager.updated.connect(self.__isEvailabel)
        '''
        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icons', 'Color.png')
        self.__action = self.create_action('Изменение палитры',
                                           icon=local_file_icon, on_click=self.__run_colors,
                                           enable_on = name_observer)
        position = self.get_position('Растер Грид', 'Инструменты')
        position.add(self.__action,size=2)
        '''
    def __isEvailabel(self):
        def isRaster(obj):
            if not isinstance(obj, axipy.Raster):
                return False
            return True
        rasters = list(filter(isRaster, axipy.da.data_manager.objects))
        if len(rasters)>0:
            #self.__observer_data_catalog.setValue(True)
            value_observer=self.__observer_data_catalog.value()
            if self.__observer_data_catalog.value():
                return
            for rast_tab in rasters:
                try:
                    raster_file=rast_tab.properties['tabFileData']['linkFile']
                    gd_grid=RasterSource()
                    gd_grid.OpenRead(raster_file)
                    if gd_grid.isGrid:
                        gd_grid.close()
                        self.__observer_data_catalog.setValue(True)
                        break
                    gd_grid.close()
                except:
                    continue
        else:
            self.__observer_data_catalog.setValue(False)
    def __isEvailabel_old(self):
        def isRaster(obj):
            if not isinstance(obj, axipy.Raster):
                return False
            return True
        rasters = list(filter(isRaster, axipy.da.data_manager.objects))
        if len(rasters)>0:
            self.__observer.setValue(True)
        else:
            self.__observer.setValue(False)
        self.__isCloseDataObject()
    def __run_colors(self):
        print("run color")
    def __isCloseDataObject(self):
        print("Is Close")
    def unload(self):
        self.__action.remove()
        if len(self.__list_cls_action)>0:
            for cls in self.__list_cls_action:
                doc_widget=cls.docWidget
                self.__removeWidget(doc_widget)

    def __removeWidget(self,doc):
        if doc is None:
            return
        DelDocWidget(axipy.app.mainwindow.qt_object(),doc)
        doc=None
        #self.__merge_doc=None