import os

import axipy
from PySide2.QtGui import QIcon
from axipy import state_manager

from .Utils.Observer import VectorTabObserver, factoryObserverTabForGrid
from .ui.addTools.VectorTabForGrid import listNumericField
from .ui.docWidget import AxiDocWidget, addDoc, existDocWidget, DelDocWidget
from .ui.variogram.DlgFormCalcVariogram import DlgCalcVariogram


class CalcVariogram:
    __name='Анализ:Вычисление вариограммы'
    __name_observer='CountTableForGrid'
    __type_observer="catalog_vector_for_grid"
    __form_tool=None
    __docWidget=None
    #__def_name_group="Анализ"
    __def_name_group="Инструменты"
    def __init__(self,parentPlugin):
        self._initTool(parentPlugin)
    def _initTool(self,parentPlugin):
        '''
        try:
            self.__observer=state_manager.find(self.__name_observer)
        except:
            pass

        if self.__observer is None:
            self.__observer=state_manager.create(self.__name_observer,False)

        axipy.da.data_manager.updated.connect(self.__isEvailabel)
        '''
        #self.__abs_observer=VectorTabObserver(self.__name_observer)
        self.__observer=factoryObserverTabForGrid(self.__name_observer)
        self.__observer.changed.connect(self.__changeValueObserver)
        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icons', 'variogram.png')
        try:
            self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.__run_calc_vario,enable_on = self.__name_observer)
        except Exception as ex:
            jkl=0
        return

    def name(self):
        return self.__name
    @property
    def name_group(self):
        return self.__def_name_group
    @property
    def action(self):
        return self.__action
    @property
    def nameObserver(self):
        return self.__name_observer
    @property
    def typeObserver(self):
        return self.__type_observer
    @property
    def docWidget(self):
        return self.__docWidget
    @property
    def form(self):
        return self.__form_tool
    def __run_calc_vario(self):
        if self.__form_tool is None:

            self.__form_tool=DlgCalcVariogram()
            self.__observer.addChildrenWidget("CalcVariogram",self.__form_tool)
        if self.__docWidget is None:
            mainwindowAxi=axipy.app.mainwindow.qt_object()
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"CalcVariogram",self.__name,QIcon(),mainwindowAxi)
            #addDoc(mainwindowAxi,self.__docWidget)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist=existDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def __isEvailabel(self):
        def isDataForGrid(obj):
            if not isinstance(obj, axipy.Table):
                return False
            numeric_field=listNumericField(obj)
            if numeric_field is None:
                return False
            return True
            '''
            schema_tab=obj.schema
            for item in schema_tab:
                if item.typedef=='double' or item.typedef=='int' or item.typedef=='integer' or (item.typedef.find("decimal")>=0):
                    return True
            return False
            '''
        tabs_for_grid = list(filter(isDataForGrid, axipy.da.data_manager.objects))
        if len(tabs_for_grid)>0:
            self.__observer.setValue(True)
        else:
            self.__observer.setValue(False)
    def __changeValueObserver(self):
        status=self.__observer.value
        if status ==False:
            if self.__docWidget is not None:
                self.__observer.removeChildrenWidget("CalcVariogram")
                DelDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)



                return
        if status:
            if self.__docWidget is not None:
                self.__form_tool= DlgCalcVariogram()
                self.__observer.addChildrenWidget("CalcVariogram",self.__form_tool)
                self.__docWidget=AxiDocWidget(self.__form_tool.widget,"CalcVariogram",self.__name,QIcon(),axipy.app.mainwindow.qt_object())
                addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
