import os

import axipy
from PySide2.QtGui import QIcon
from axipy import view_manager

from .Utils.Observer import factoryObserverRaster
from .ui.clipRaster.DlgFormClipRaster import FromClipRaster
from .ui.docWidget import AxiDocWidget, addDoc, DelDocWidget, existDocWidget


class ClipRaster:
    __name='Отсечение растра'
    __name_observer='openRaster'
    __type_observer="catalog"
    __form_tool=None
    __docWidget=None
    __def_name_group="Действие"
    def __init__(self,parentPlugin):
        self._initTool(parentPlugin)
    def _initTool(self,parentPlugin):
        self.__observer=factoryObserverRaster(self.__name_observer)
        self.__observer.changed.connect(self.__changeValueObserver)
        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icons', 'clip_32x32.png')
        try:
            self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.__run_clip,enable_on = self.__name_observer)
        except Exception as ex:
            jkl=0
        return
    @property
    def name(self):
        return self.__name
    @property
    def name_group(self):
        return self.__def_name_group
    @property
    def action(self):
        return self.__action
    @property
    def nameObserver(self):
        return self.__name_observer
    @property
    def typeObserver(self):
        return self.__type_observer
    @property
    def docWidget(self):
        return self.__docWidget
    @property
    def form(self):
        return self.__form_tool
    def __changeValueObserver(self):
        value_observer=self.__observer.value
        if not value_observer:
            if self.__docWidget is not None:
                DelDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
                self.__observer.removeChildrenWidget(self.__name_observer)

                self.__docWidget=None
                self.__form_tool=None
                return
        if self.__docWidget is not None:

            self.__form_tool=FromClipRaster(axipy.app.mainwindow.qt_object())
            self.__observer.addChildrenWidget(self.__name_observer,self.__form_tool)
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"ClipRaster",self.__name,QIcon(),axipy.app.mainwindow.qt_object())
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
        else:
            isExist=existDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
            if isExist:
                self.__docWidget.setVisible(True)
                self.__docWidget.setFocus()
                self.__docWidget.raise_()

    def __run_clip(self):
        if self.__form_tool is None:

            self.__form_tool=FromClipRaster(view_manager.global_parent)
            self.__form_tool.updateTables()
            self.__observer.addChildrenWidget("CreateContour",self.__form_tool)
        else:
            self.__form_tool.updateTables()
        if self.__docWidget is None:
            self.__form_tool.updateTables()
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"ClipRaster",self.__name,QIcon(),view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
        else:
            isExist=existDocWidget(view_manager.global_parent,self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()