import os

import axipy
from PySide2.QtGui import QIcon
from axipy import state_manager, view_manager

#from .Utils.Observer import factoryObserverTabGrid
from .Utils.helper_observer import factoryGridObserver, factoryBoolGridObserver
from .grid_io.ColorPaletts import ColorsPalett
from .ui.DlgFormPalette import FormPalette
from .ui.docWidget import AxiDocWidget, addDoc, existDocWidget, DelDocWidget


class ColorPaletteTools:
    __name='Изменение палитры'
    __name_observer='CountTableGrid'
    __name_observer = 'GridAxi'
    __name_observer = 'BoolGridAxi'
    __type_observer="catalog"
    __form_tool=None
    __docWidget=None
    __def_name_group="Инструменты"
    def __init__(self,parentPlugin):
        self._initTool(parentPlugin)
        self.__cls_colors=None
    def _initTool(self,parentPlugin):
        #self.__observer=factoryObserverTabGrid(self.__name_observer)
        #self.__observer=factoryGridObserver(self.__name_observer)
        self.__observer=factoryBoolGridObserver(self.__name_observer)
        self.__observer.changed.connect(self.__changeValueObserver)
        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icons', 'Color.png')
        try:
            self.__action=parentPlugin.create_action('Изменение палитры',icon=local_file_icon, on_click=self.__run_colors,enable_on = self.__name_observer)
        except Exception as ex:
            jkl=0
        return
    @property
    def name(self):
        return self.__name
    @property
    def name_group(self):
        return self.__def_name_group
    @property
    def action(self):
        return self.__action
    @property
    def nameObserver(self):
        return self.__name_observer
    @property
    def docWidget(self):
        return self.__docWidget
    @property
    def form(self):
        return self.__form_tool
    def __changeValueObserver(self):
        value_observer=self.__observer.value
        if not value_observer:
            if self.__docWidget is not None:
                DelDocWidget(view_manager.global_parent,self.__docWidget)
                #self.__observer.removeChildrenWidget(self.__name_observer)

                self.__docWidget=None
                self.__form_tool=None
                print("Disable ColorPalette")
                return
        if self.__docWidget is not None:
            if self.__cls_colors is None:
                self.__cls_colors=ColorsPalett()
            self.__form_tool=FormPalette(self.__cls_colors)
            #self.__observer.addChildrenWidget(self.__name_observer,self.__form_tool)
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"ChangePalette","Изменение палитры",QIcon(),view_manager.global_parent)
            addDoc(view_manager.global_parent,self.__docWidget)
            print("Enable ColorPalette")
    @property
    def typeObserver(self):
        return self.__type_observer
    def __run_colors(self):
        if self.__form_tool is None:
            if self.__cls_colors is None:
                self.__cls_colors=ColorsPalett()
            self.__form_tool=FormPalette(self.__cls_colors)
        self.__form_tool.update_table_grid()
        if self.__docWidget is None:
            mainwindowAxi=view_manager.global_parent
            #self.__observer.addChildrenWidget(self.__name_observer,self.__form_tool)
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"ChangePalette","Изменение палитры",QIcon(),mainwindowAxi)
            #addDoc(mainwindowAxi,self.__docWidget)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist=existDocWidget(view_manager.global_parent,self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    @staticmethod
    def factory(parentPlugin):
        cls_colorPalette=ColorPaletteTools(parentPlugin)
        if cls_colorPalette.action is not None:
            return cls_colorPalette
        return None

