import os

import axipy
from PySide2.QtGui import QIcon
from axipy import state_manager, view_manager

from RasterGridTool.toolprocessing.Utils.Observer import VectorTabObserver, factoryObserverTabForGrid
from RasterGridTool.toolprocessing.Utils.helper_observer import factoryObserverTabOneNumberField
from RasterGridTool.toolprocessing.ui.DlgCreateGrid import DlgCreateGrid
from RasterGridTool.toolprocessing.ui.addTools.VectorTabForGrid import listNumericField
from RasterGridTool.toolprocessing.ui.docWidget import AxiDocWidget, addDoc, DelDocWidget, existDocWidget
from RasterGridTool.toolprocessing.ui.formCreateGrid import FromCreateGrid


class CreateGrid:
    __name='Создание тепловой карты'
    __name_observer='CountTableForGrid'
    __name_observer='VectorOneNumber'
    __type_observer="catalog_vector_for_grid"
    __form_tool=None
    __docWidget=None
    #__def_name_group="Создание тепловой карты"
    __def_name_group="Инструменты"
    def __init__(self,parentPlugin):
        self._initTool(parentPlugin)
    def _initTool(self,parentPlugin):
        '''
        try:
            self.__observer=state_manager.find(self.__name_observer)
        except:
            pass
        if self.__observer is None:
            self.__observer=state_manager.create(self.__name_observer,False)
        axipy.da.data_manager.updated.connect(self.__isEvailabel)

        self.__observer.changed.connect(self.__changeValueObserver)
        '''
        #self.__abs_observer=VectorTabObserver(self.__name_observer)
        self.__observer=factoryObserverTabOneNumberField(self.__name_observer)
        #self.__observer=factoryObserverTabForGrid(self.__name_observer)
        self.__observer.changed.connect(self.__changeValueObserver)
        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icons', 'createGrid_32X32.png')
        try:
            self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.__run_create_grid,enable_on = self.__name_observer)
        except Exception as ex:
            jkl=0
        return
    @property
    def name(self):
        return self.__name
    @property
    def name_group(self):
        return self.__def_name_group
    @property
    def action(self):
        return self.__action
    @property
    def nameObserver(self):
        return self.__name_observer
    @property
    def typeObserver(self):
        return self.__type_observer
    @property
    def docWidget(self):
        return self.__docWidget
    @property
    def form(self):
        return self.__form_tool
    def __run_create_grid(self):
        if self.__form_tool is None:

            #self.__form_tool= FromCreateGrid(view_manager.global_parent)
            print("Create Grid 1")
            self.__form_tool = FromCreateGrid()
            #self.__observer.addChildrenWidget("CreateGrid",self.__form_tool)
        if self.__docWidget is None:
            mainwindowAxi=view_manager.global_parent
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"CreateGrid",self.__name,QIcon(),mainwindowAxi)
            #addDoc(mainwindowAxi,self.__docWidget)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist = existDocWidget(view_manager.global_parent, self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def __isEvailabel(self):
        def isDataForGrid(obj):
            if not isinstance(obj, axipy.Table):
                return False
            numeric_field=listNumericField(obj)
            if numeric_field is None:
                return False
            return True
            '''
            schema_tab=obj.schema
            for item in schema_tab:
                if item.typedef=='double' or item.typedef=='int' or item.typedef=='integer' or (item.typedef.find("decimal")>=0):
                    return True
            return False
            '''
        tabs_for_grid = list(filter(isDataForGrid, axipy.da.data_manager.objects))
        if len(tabs_for_grid)>0:
            self.__observer.setValue(True)
            if self.__form_tool is not None:
                list_cur_table_widget=self.__form_tool.allTabelNames
            jkl=0
        else:
            self.__observer.setValue(False)

    def __changeValueObserver(self):
        status=self.__observer.value
        if status ==False:
            if self.__docWidget is not None:
                DelDocWidget(view_manager.global_parent,self.__docWidget)
                #self.__observer.removeChildrenWidget("CreateGrid")
                return
        if status:
            if self.__docWidget is not None:
                print("Create Grid 2")
                self.__form_tool= FromCreateGrid()
                #self.__observer.addChildrenWidget("CreateGrid",self.__form_tool)
                self.__docWidget=AxiDocWidget(self.__form_tool.widget,"CreateGrid",self.__name,QIcon(),view_manager.global_parent)
                addDoc(view_manager.global_parent,self.__docWidget)


