import axipy
from PySide2.QtCore import QObject
from axipy import ObserverManager, data_manager, Raster

from  RasterGridTool.toolprocessing.grid_io.GdalSource import RasterSource
from RasterGridTool.toolprocessing.ui.addTools.VectorTabForGrid import listNumericField

def getName(list_tables):
    out_list=[]
    for tab in list_tables:
        out_list.append(tab.name)
    return out_list
def isDataForGridTab(self,obj):
    if not isinstance(obj, axipy.Table):
        return False
    numeric_field=listNumericField(obj)
    if numeric_field is None:
        return False
    return True
class VectorTabObserver(QObject):
    def __init__(self,name_observer):
        super(VectorTabObserver, self).__init__()
        self.__observer=None
        self.__name_observer=name_observer
        self.__createObsetver(name_observer)
        self.__children_widgets=None
    def __createObsetver(self,name):
        try:
            self.__observer=ObserverManager.get(self.__name_observer)
        except:
            pass
        if self.__observer is None:
            self.__observer=ObserverManager.create(self.__name_observer,False)
        #axipy.da.data_manager.updated.connect(self.__isEvailabel)
        axipy.da.data_manager.added.connect(self.__addTable)
        axipy.da.data_manager. removed.connect(self.__removedTable)
    def addChildrenWidget(self,name_tool,widget):
        if self.__children_widgets is None:
            self.__children_widgets={}

        self.__children_widgets[name_tool]=widget
    def removeChildrenWidget(self,name):
        if self.__children_widgets is None:
            return
        del self.__children_widgets[name]
    def __isEvailabel(self):
        def isDataForGrid(obj):
            if not isinstance(obj, axipy.Table):
                return False
            numeric_field=listNumericField(obj)
            if numeric_field is None:
                return False
            return True
            '''
            schema_tab=obj.schema
            for item in schema_tab:
                if item.typedef=='double' or item.typedef=='int' or item.typedef=='integer' or (item.typedef.find("decimal")>=0):
                    return True
            return False
            '''
        tabs_for_grid = list(filter(isDataForGrid, axipy.da.data_manager.objects))
        if len(tabs_for_grid)>0:
            self.__observer.value=True
            '''
            if self.__form_tool is not None:
                list_cur_table_widget=self.__form_tool.allTabelNames
            '''
            if self.__children_widgets is None:
                return
            list_names_tab=getName(tabs_for_grid)
            for name in self.__children_widgets.keys():
                try:
                    #list_cur_table_widget=self.__children_widgets[name].allTabelNames
                    self.__children_widgets[name].updateTableList(list_names_tab)
                except:
                    pass
            jkl=0

        else:
            self.__observer.value=False
    def isDataForGridTab(self,obj):
        if not isinstance(obj, axipy.Table):
            return False
        numeric_field=listNumericField(obj)
        if numeric_field is None:
            return False
        return True
    def __addTable(self,name_tab):
        tab=axipy.da.data_manager.find(name_tab)
        tabForGrid= self.isDataForGridTab(tab)
        if (not self.__observer.value) and tabForGrid:
            self.__observer.value=True
            return
        if self.__children_widgets is not None and tabForGrid:
            for name in self.__children_widgets.keys():
                try:
                    self.__children_widgets[name].addTable(name_tab)
                except:
                    pass
        return
    def __removedTable(self,name_tab):
        tab=axipy.da.data_manager.find(name_tab)
        tabForGrid= self.isDataForGridTab(tab)
        disable=True
        if self.__children_widgets is not None and tabForGrid:
            for name in self.__children_widgets.keys():
                try:
                    count_tab=self.__children_widgets[name].removeTable(name_tab)
                    if count_tab==0:
                        disable=False
                except:
                    pass
        else:
            disable=False
        self.__observer.value=disable
    @property
    def observer(self):
        return self.__observer
def isDataForGridTab(obj):
    if not isinstance(obj, axipy.Table):
        return False
    numeric_field=listNumericField(obj)
    if numeric_field is None:
        return False
    return True
def isRasterTab(tab):
    return isinstance(tab, axipy.Raster)
def isGridTab(tab):
    if not isinstance(tab, axipy.Raster):
        return False

    #raster_file=tab.properties['tabFileData']['linkFile']
    raster_file=tab.properties['fileName']
    gd_grid=RasterSource()
    gd_grid.OpenRead(raster_file)
    isGrid=False
    if gd_grid.isGrid:
        isGrid=True

    gd_grid.close()
    return isGrid
def factoryObserverTabForGrid(name_observer):
    observer=None
    try:
        observer=ObserverManager.get(name_observer)
    except:
        pass
    if observer is None:
        observer=ObserverManager.create(name_observer,False)
        def addTable(name_table):
            tab=axipy.da.data_manager.find(name_table)
            tabForGrid= isDataForGridTab(tab)
            if (not observer.value) and tabForGrid:
                observer.value=True
                return
            if  tabForGrid:
                for name in observer.children_widgets.keys():
                    try:
                        observer.children_widgets[name].addTable(name_table)
                    except:
                        pass
            return

        def removedTable(name_table):
            tab=axipy.da.data_manager.find(name_table)
            tabForGrid= isDataForGridTab(tab)
            if not tabForGrid:
                return
            tabs_for_grid = list(filter(isDataForGridTab, axipy.da.data_manager.objects))
            if len(tabs_for_grid)==1:
                observer.value=False
                return
            for name in observer.children_widgets.keys():
                try:
                    observer.children_widgets[name].removeTable(name_table)
                except:
                    pass
        def addChildrenWidget(name_tool,widget):
            observer.children_widgets[name_tool]=widget
        def removeChildrenWidget(name):
            try:
                del observer.children_widgets[name]
            except:
                pass

        setattr(observer, "children_widgets", {})
        setattr(observer, "addTable", addTable)
        setattr(observer, "removedTable", removedTable)
        setattr(observer, "addChildrenWidget", addChildrenWidget)
        setattr(observer, "removeChildrenWidget", removeChildrenWidget)
        axipy.da.data_manager.added.connect(observer.addTable)
        axipy.da.data_manager.removed.connect(observer.removedTable)
    return observer
def factoryObserverTabGrid(name_observer):
    observer=None
    try:
        observer=ObserverManager.get(name_observer)
    except:
        pass
    if observer is None:
        observer=ObserverManager.create(name_observer,False)
        def addTable(name_table):
            tab=axipy.da.data_manager.find(name_table)
            tabForGrid= isGridTab(tab)
            if (not observer.value) and tabForGrid:
                observer.value=True
            if tabForGrid:
                for name in observer.children_widgets.keys():
                    try:
                        observer.children_widgets[name].addTable(name_table)
                    except:
                        pass



            return

        def removedTable(name_table):
            tab=axipy.da.data_manager.find(name_table)
            tabForGrid= isGridTab(tab)
            if not  tabForGrid:
                return
            tabs_for_grid = list(filter(isGridTab, axipy.da.data_manager.objects))
            if len(tabs_for_grid)==1:
                observer.value=False
                return
            for name in observer.children_widgets.keys():
                try:
                    observer.children_widgets[name].removeTable(name_table)
                except:
                    pass
        def addChildrenWidget(name_tool,widget):
            observer.children_widgets[name_tool]=widget
        def removeChildrenWidget(name):
            try:
                del observer.children_widgets[name]
            except:
                pass

        setattr(observer, "children_widgets", {})
        setattr(observer, "addTable", addTable)
        setattr(observer, "removedTable", removedTable)
        setattr(observer, "addChildrenWidget", addChildrenWidget)
        setattr(observer, "removeChildrenWidget", removeChildrenWidget)
        axipy.da.data_manager.added.connect(observer.addTable)
        axipy.da.data_manager. removed.connect(observer.removedTable)
        return observer

    return observer
def factoryObserverRaster(name_observer):
    observer=None
    try:
        observer=ObserverManager.get(name_observer)
    except:
        observer=None
    if observer is None:
        observer=ObserverManager.create(name_observer,False)
    def addTable(name_table):
        tab=axipy.da.data_manager.find(name_table)
        tab_raster= isinstance(tab,axipy.da.Raster)
        if (not observer.value) and tab_raster:
            observer.value=True
        if tab_raster:
            for name in observer.children_widgets.keys():
                try:
                    observer.children_widgets[name].addTable(name_table)
                except:
                    pass



        return

    def removedTable(name_table):
        tab=axipy.da.data_manager.find(name_table)
        tab_raster= isinstance(tab,axipy.da.Raster)
        if not  tab_raster:
            return
        tabs_for_grid = list(filter(isRasterTab, axipy.da.data_manager.objects))
        if len(tabs_for_grid)==1:
            observer.value=False
            return
        for name in observer.children_widgets.keys():
            try:
                observer.children_widgets[name].removeTable(name_table)
            except:
                pass
    def addChildrenWidget(name_tool,widget):
        observer.children_widgets[name_tool]=widget
    def removeChildrenWidget(name):
        try:
            del observer.children_widgets[name]
        except:
            pass

    setattr(observer, "children_widgets", {})
    setattr(observer, "addTable", addTable)
    setattr(observer, "removedTable", removedTable)
    setattr(observer, "addChildrenWidget", addChildrenWidget)
    setattr(observer, "removeChildrenWidget", removeChildrenWidget)
    axipy.da.data_manager.added.connect(observer.addTable)
    axipy.da.data_manager. removed.connect(observer.removedTable)
    for item in data_manager.objects:
        if isinstance(item,Raster):
            observer.value=True
            break
    return observer

