import axipy
from axipy import data_manager, Raster, Table

from RasterGridTool.toolprocessing.ui.viewshade.tools.helper_raster import AxiRaster

def existOneNumberField(tab):
    ''' Проверка есть хотя бы одно числовое поле'''

    for att in tab.schema:
        if att.type_string == "int" or att.type_string == 'double' or att.type_string=='decimal':
            return True
    return False
def factoryGridObserver(name_observer):
    observer = None
    try:
        observer = axipy.ObserverManager.get(name_observer)
    except:
        pass
    if observer is not None:
        return observer
    observer = axipy.ObserverManager.create(name_observer, False)
    '''Добавляем список растров - grid'''
    setattr(observer, "list_grid", {})
    #observer.list_grid={}
    def addRaster(name_tab):
        tab_add=data_manager.find(name_tab)
        if not isinstance(tab_add,Raster):
            if len(list(observer.list_grid.keys()))==0:
                observer.value=False
            else:
                observer.value = observer.list_grid
            return
        raster_grid=AxiRaster(tab_add)
        if not raster_grid.IsGrid:
            return
        observer.list_grid[name_tab]=raster_grid
        observer.value = observer.list_grid
        return
    def removeRaster(name_tab):
        if name_tab in observer.list_grid:
            del observer.list_grid[name_tab]
            if len(list(observer.list_grid.keys())) == 0:
                observer.value = False
            return
    def init():
        for obj in data_manager.objects:
            if not isinstance(obj,Raster):
                continue
            raster_grid = AxiRaster(obj)
            if not raster_grid.IsGrid:
                return
            observer.list_grid[obj.name] = raster_grid
        if len(list(observer.list_grid.keys())) == 0:
            observer.value = False
        else:
            observer.value = observer.list_grid
        return
    setattr(observer, "remove_table", removeRaster)
    setattr(observer, "add_table", addRaster)
    setattr(observer, "init_observer", init)
    observer.init_observer()
    data_manager.removed.connect(observer.remove_table)
    data_manager.added.connect(observer.add_table)
    return observer
def factoryBoolGridObserver(name_observer,name_grid='GridAxi'):
    observer=None
    try:
        observer = axipy.ObserverManager.get(name_observer)
    except:
        pass
    if observer is not None:
        return observer
    observer_grid=None
    observer_grid= axipy.ObserverManager.get(name_grid)
    if observer_grid is None:
        observer_grid=factoryGridObserver(name_grid)
    observer = axipy.ObserverManager.create(name_observer, False)
    def updateChildrenObserver():
        if observer_grid.value:
            observer.value=True
        else:
            observer.value = False

    setattr(observer, "updateChildren", updateChildrenObserver)
    observer_grid.changed.connect(observer.updateChildren)
    if observer_grid.value:
        observer.value=True
    else:
        observer.value=False
    return observer
def factoryVectorGridObserver(name_observer,name_grid_observer):
    observer_vector_grid = None
    try:
        observer_vector_grid = axipy.ObserverManager.get(name_observer)
    except:
        pass
    if observer_vector_grid is not None:
        return observer_vector_grid
    observer_vector_grid = axipy.ObserverManager.create(name_observer, False)
    observer_grid=factoryGridObserver(name_grid_observer)
    def existVectorTab():
        if not axipy.ObserverManager.HasTables.value:
            observer_vector_grid.value=False
            return
        existGrid=observer_grid.value
        if not existGrid:
            observer_vector_grid.value = False
            return
        observer_vector_grid.value = True
        return
    def updateGrids():
        if not observer_grid.value:
            observer_vector_grid.value = False
            return
        for tab in data_manager.tables:
            existNumber = existOneNumberField(tab)
            if existNumber:
                observer_vector_grid.value = True
                return
        observer_vector_grid.value = False
        return
    def addTables(name_tab):

        if observer_vector_grid.value:
            return
        if not observer_grid.value:
            observer_vector_grid.value = False
            return
        tab=data_manager.find(name_tab)
        if not isinstance(tab,Table):
            return
        existNumber=existOneNumberField(tab)
        if existNumber:
            observer_vector_grid.value = True
            return

    def removeTable(name_tab):
        if not observer_vector_grid.value:
            return
        tab = data_manager.find(name_tab)
        if not isinstance(tab,Table):
            return
        existNumber = existOneNumberField(tab)
        if not existNumber:
            return
        for tab in data_manager.tables:
            if tab.name==name_tab:
                continue
            existNumber = existOneNumberField(tab)
            if existNumber:
                return
        observer_vector_grid.value = False
        return
    def init():
        if not observer_grid.value:
            observer_vector_grid.value = False
            return
        for tab in data_manager.tables:
            existNumber = existOneNumberField(tab)
            if existNumber:
                if observer_grid.value:
                    observer_vector_grid.value=True
                    return
        observer_vector_grid.value = False
        return
    #setattr(observer_vector_grid, "existVector", existVectorTab)
    setattr(observer_vector_grid, "addTables", addTables)
    setattr(observer_vector_grid, "removeTable", removeTable)
    setattr(observer_vector_grid, "init", init)
    setattr(observer_vector_grid, "updateGrids", updateGrids)

    observer_vector_grid.init()
    data_manager.added.connect(observer_vector_grid.addTables)
    data_manager.removed.connect(observer_vector_grid.removeTable)
    observer_grid.changed.connect(observer_vector_grid.updateGrids)
    return observer_vector_grid
def factoryObserverTabOneNumberField(name_observer):
    observer = None
    try:
        observer = axipy.ObserverManager.get(name_observer)
    except:
        pass
    if observer is not None:
        return observer
    observer=axipy.ObserverManager.create(name_observer, False)
    def init():

        for tab in data_manager.tables:
            existNumber = existOneNumberField(tab)
            if existNumber:
                observer.value=True
                return
        observer.value = False
        return
    def addTable(name_tab):
        if observer.value:
            return
        tab=data_manager.find(name_tab)
        if not isinstance(tab,Table):
            return
        existNumber = existOneNumberField(tab)
        if existNumber:
            observer.value = True
            return

        observer.value = False
        return
    def removeTable(name_tab):
        if not observer.value:
            return
        tab = data_manager.find(name_tab)
        if not isinstance(tab,Table):
            return
        existNumber = existOneNumberField(tab)
        if not existNumber:
            return
        for tab in data_manager.tables:
            if tab.name==name_tab:
                continue
            existNumber = existOneNumberField(tab)
            if existNumber:
                return
        observer.value = False
        return
    setattr(observer, "init", init)
    setattr(observer, "addTable", addTable)
    setattr(observer, "removeTable", removeTable)
    data_manager.added.connect(observer.addTable)
    data_manager.removed.connect(observer.removeTable)
    observer.init()
    return observer
def factoryVectorNumberFieldAndGrid(name_base_observer,name_grid="GridAxi",name_vector_oneNumber="VectorOneNumber"):
    observer_grid=axipy.ObserverManager.get(name_grid)
    if observer_grid is None:
        observer_grid=factoryGridObserver(name_grid)
    observer_vector_one_number=axipy.ObserverManager.get(name_vector_oneNumber)
    if observer_vector_one_number is None:
        observer_vector_one_number=factoryObserverTabOneNumberField(name_vector_oneNumber)
    observer=axipy.ObserverManager.get(name_base_observer)
    if observer is not None:
        return observer
    observer = axipy.ObserverManager.create(name_base_observer, False)
    def updateChilObservers():
        if observer_vector_one_number.value and observer_grid.value:
            observer.value=True
            return
        observer.value = False
        return

    setattr(observer, "updaterChildren", updateChilObservers)
    observer_vector_one_number.changed.connect(observer.updaterChildren)
    observer_grid.changed.connect(observer.updaterChildren)
    return observer




