import os
from pathlib import Path

from RasterGridTool.toolprocessing.ui.Palette.tools.ColorTable import ColorTable, ColorMap


#from .ColorTable import ColorTable


class ColorsPalett:
    def __init__(self,folder_clr=None):
        self.__folder_pallet=folder_clr
        if folder_clr is None:
            script_dir = Path( __file__ ).parent.absolute()
            self.__folder_pallet=os.path.join(script_dir,'ColorPalettes')
        self.__loadClrs()
    def __loadClrs(self):
        list_files=os.listdir(self.__folder_pallet)
        self.__list_color_tabs=[]
        for clr_file in list_files:
            path_file=os.path.join(self.__folder_pallet,clr_file)
            cls_tab=ColorTable(ColorMap(path_file))
            #count_color=cls_tab.LoadClr(path_file)
            name_palette=clr_file.replace('.clr','')

            self.__list_color_tabs.append({'name':name_palette,'color_tab':cls_tab})
        return
    @property
    def count(self):
        return len(self.__list_color_tabs)
    def getNameAndImage(self,index,width,height):
        color_tab_item=self.__list_color_tabs[index]
        name=color_tab_item['name']
        color_tab=color_tab_item['color_tab']
        image=color_tab.getQImageBaseClr(width,height)
        return name,image
    def getColorTable(self,name_palette)->ColorTable:
        for item_color in self.__list_color_tabs:
            if item_color['name']==name_palette:
                return item_color['color_tab']
        return None
