import os
from pathlib import Path

def_charset_string='!charset'
def getPythonCharSet(char_set_mi):
    if char_set_mi.lower()=='windowscyrillic':
        return 'cp1251'
    if char_set_mi.lower()=='utf-8':
        return 'utf-8'
    return 'latin1'
class MiTabFileRaster:
    __isOkOpen=False
    __axiomaGridColor=False
    __name_color_vrt=None
    def __init__(self,path_file):
        self.__pathFile=path_file
        self.__readFile()
    @classmethod
    def createClass(cls,path_file):
        if not os.path.exists(path_file):
            return None
        return cls(path_file)
    def __readFile(self):
        char_set=None
        with open(self.__pathFile, 'r', encoding='latin1') as tabfile:
            for line in tabfile:
                new_line=line.rstrip()
                if new_line.lower().find(def_charset_string)==0:
                    char_set=new_line[(len(def_charset_string)+1):]
                    char_set=char_set.strip()
                    break
        if char_set is None:
            return
        self.__curentCharset=getPythonCharSet(char_set)
        self.__base_lines=[]
        self.__metadata=[]
        with open(self.__pathFile, 'r', encoding=self.__curentCharset) as tabfile:
            for line in tabfile:
                new_line=line.rstrip()
                if new_line=='begin_metadata':
                    self.__metadata.append(new_line)
                else:
                    if len(self.__metadata)==0:
                        self.__base_lines.append(new_line)
                    else:
                        if new_line.find('\\Axioma\\GridColor')>=0:
                            self.__axiomaGridColor=True
                        self.__metadata.append(new_line)
        return
    def setGridColorVrt(self,name_color_vrt):
        self.__name_color_vrt=name_color_vrt
        if not self.__axiomaGridColor:
            if len(self.__metadata)==0:
                self.__metadata.append('begin_metadata')
                self.__metadata.append('"\\Axioma\\GridColor"="'+self.__name_color_vrt+'"')
                self.__metadata.append('end_metadata')
            else:
                self.__metadata.insert(1,'"\\Axioma\\GridColor"="'+self.__name_color_vrt+'"')
        else:
            for i,line_meta in enumerate(self.__metadata):
                if line_meta.find('"\\Axioma\\GridColor"')>=0:
                    self.__metadata[i]='"\\Axioma\\GridColor"="'+self.__name_color_vrt+'"'
                    break
    def setNewRaster(self,path_raster):
        for i,line in enumerate(self.__base_lines):
            if line.strip().lower().find("file")==0:
                self.__base_lines[i]='File "' +path_raster+'"'
                break

    def saveAs(self,path_out=None):
        path_out_temp=path_out
        if path_out_temp is None:
            path_out_temp=self.__pathFile
        with open(path_out_temp, 'w', encoding=self.__curentCharset) as tabfile:
            for line in self.__base_lines:
                if line.strip().lower().find("rasterstyle")==0:
                    continue
                tabfile.write(line+"\n")

            if len(self.__metadata)>0:
                for line in self.__metadata:
                    tabfile.write(line+"\n")
    @staticmethod
    def copyChangeRaster(source_tab,new_raster,out_tab):
        source_mi=MiTabFileRaster(source_tab)

def gridColorChildeExist(grid_parent,list_grid):
    for grid in list_grid:
        if not grid.existPalette:
            continue
        name_color_vrt_tab=grid.colorGridTab
        base_raster=grid.baseRaster
        if base_raster is None :
            continue
        base_grids=base_raster.baseRaster
        if base_grids is None or len(base_grids)==0:
            continue
        base_grid_name=base_grids[0]['file']
        path_parent_grid=grid_parent.pathRastre
        name_grid=Path(path_parent_grid).name
        if name_grid!=base_grid_name:
            continue
        return name_color_vrt_tab,grid.baseRaster.colorFile
    return None,None








