import os
import pathlib

import axipy
from PySide2.QtCore import QFile
from PySide2.QtGui import QIcon, QPixmap, Qt
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QListWidgetItem, QTableWidgetItem, QLabel, QGraphicsScene, QGraphicsPixmapItem

from RasterGridTool.toolprocessing.grid_io.VrtGridColorNewPalette import RasterGrid
#from RasterGridTool.toolprocessing.grid_io.ColorTable import ColorTable
#from RasterGridTool.toolprocessing.grid_io.VrtGridColor import getColorTabVrt, RasterGrid
from RasterGridTool.toolprocessing.grid_io.utils import gridColorChildeExist
from RasterGridTool.toolprocessing.ui.Palette.DlgColorGridNew import DlgColorGridGdal
from RasterGridTool.toolprocessing.ui.Palette.tools.ColorTable import ColorTable
from RasterGridTool.toolprocessing.ui.addTools.utils import getListGridTab, getGridColor
from RasterGridTool.toolprocessing.ui.viewshade.tools.helper_raster import getClassAxiGrid


class FormPalette(QWidget):
    __name_observer_grid = 'GridAxi'
    def __init__(self,paletts,parent=None):
        self.__parentWin=parent
        self.__paletts=paletts
        self.load_ui('DlgFormChangePaletteNew.ui')
        self.__initListWidget()
        self.ui.cmb_grids_tab.currentIndexChanged.connect(self.__chageGridTab)
        self.ui.table_palette.itemSelectionChanged.connect(self.__selectPalette)
        self.ui.pb_config_pal.clicked.connect(self.__run_detail_config_pal)
        self.ui.pb_run.clicked.connect(self.__run)
        #self.__scene = QGraphicsScene(self.ui)
    def __initListWidget(self):
        count=self.__paletts.count
        self.ui.table_palette.setRowCount(count)
        self.ui.table_palette.setColumnCount(2)
        self.ui.table_palette.setColumnWidth(0, 100)
        self.ui.table_palette.setColumnWidth(1, 100)

        j=-1
        #count=3
        for i in range(count):
            try:
                name,image=self.__paletts.getNameAndImage(i,200,20)
                print(name)
            except Exception as ex:
                pass
                continue
            #icon=QIcon()
            r_col_name=QTableWidgetItem(name)
            r_col_name.setFlags(r_col_name.flags() ^ Qt.ItemIsEditable)

            #icon.addPixmap(QPixmap.fromImage(image))
            #pixmap=QPixmap.fromImage(image)
            r_col_image=QTableWidgetItem()
            r_col_image.setData(Qt.DecorationRole, QPixmap.fromImage(image))
            r_col_image.setFlags(r_col_image.flags() ^ Qt.ItemIsEditable)
            j=j+1
            self.ui.table_palette.setItem(j,0,r_col_name)
            self.ui.table_palette.setItem(j,1,r_col_image)

        self.ui.table_palette.resizeColumnsToContents()
    def update_table_grid(self,curent_index=0):
        self.__list_grid=getListGridTab()
        self.__list_color_grid=getGridColor(self.__list_grid)
        self.ui.cmb_grids_tab.clear()
        for grid in self.__list_grid:
            self.ui.cmb_grids_tab.addItem(grid.name)
        self.ui.cmb_grids_tab.setCurrentIndex(curent_index)
    def __selectPalette(self):
        item_select=self.ui.table_palette.currentItem()

        self.__setEnableRun(True)
    def __chageGridTab(self):
        #size_image_pal=self.ui.palette_grid_select.size()
        size_image_pal=self.ui.lb_curent_palett.size()
        width_img=size_image_pal.width()
        height_img=size_image_pal.height()
        #name_tab=self.ui.cmb_grids_tab.currentText()
        index_grid=self.ui.cmb_grids_tab.currentIndex()
        tab_select=self.__list_grid[index_grid]
        name_sel_raster=self.ui.cmb_grids_tab.currentText()
        #self.__axiGrid=getClassAxiGrid(name_sel_raster)
        #self.__curentRasterGrid=self.__axiGrid.rasterSource
        self.__curentRasterGrid=RasterGrid(tab_select)
        #if self.__curentRasterGrid.isVrt:
        self.ui.pb_config_pal.setEnabled(self.__curentRasterGrid.IsVrt)
        color_tab_curent=self.__curentRasterGrid.colorTable
        if color_tab_curent is None:
            color_tab_curent=ColorTable()
            color_tab_curent.initGray()

            color_tab_curent.setZminZmax(self.__curentRasterGrid.MinZ,self.__curentRasterGrid.MaxZ)
        '''
        raster_file=tab_select.properties['tabFileData']['linkFile']
        ext_file= pathlib.Path(raster_file).suffix
        ext_file=ext_file.replace(".",'')
        color_tab_curent=None
        if ext_file=='vrt':
            # VRT имеет описание палитры LUT
            color_tab_curent=getColorTabVrt(raster_file)
        else:
            color_tab=ColorTable()
            color_tab.initGray()
            color_tab_curent=  color_tab
        '''
        image=color_tab_curent.getQImageBaseClr(width_img,height_img)
        pix_map=QPixmap.fromImage(image)
        #item = QGraphicsPixmapItem(pix_map)
        #self.__scene.addItem(item)
        #self.ui.palette_grid_select.setScene(self.__scene)
        self.ui.lb_curent_palett.setPixmap(pix_map)
        self.__setEnableRun(False)
    def addTable(self,name_tab):
        #self.update_table_grid(self.ui.cmb_grids_tab.currentIndex())

        self.ui.cmb_grids_tab.addItem(name_tab)
        tab_raster=axipy.da.data_manager.find(name_tab)
        self.__list_grid.append(tab_raster)

    def removeTable(self,name_tab):
        #self.update_table_grid()

        index_tab_exist=self.ui.cmb_grids_tab.findText(name_tab)
        if index_tab_exist>=0:
            self.ui.cmb_grids_tab.removeItem(index_tab_exist)
            for i,rast_tab in enumerate(self.__list_grid):
                if rast_tab.name==name_tab:
                    del self.__list_grid[i]
                    break


        return self.ui.cmb_grids_tab.count()
    def load_ui(self,name_resource):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.ui  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    def __run(self):
        row_sel=self.ui.table_palette.currentRow()
        name_palette=self.ui.table_palette.item(row_sel,0).text()
        color_table=self.__paletts.getColorTable(name_palette)
#color_table=ColorTable.createDefault()
        self.__curentRasterGrid.updateColorTable(color_table)
        self.__list_grid=getListGridTab()
        self.__list_color_grid=getGridColor(self.__list_grid)
        curent_name_grid=self.__curentRasterGrid.axiRasterTab.name
        curent_index_tab=0
        self.ui.cmb_grids_tab.clear()
        for i,grid in enumerate(self.__list_grid):
            self.ui.cmb_grids_tab.addItem(grid.name)
            if curent_name_grid==grid.name:
                curent_index_tab=i
        try:
            self.ui.cmb_grids_tab.setCurrentIndex(curent_index_tab)
        except Exception as ex:
            jkl=0
        return
    def __run_detail_config_pal(self):
        index_tab=self.ui.cmb_grids_tab.currentIndex()
        colorTabCurent=self.__curentRasterGrid.colorTable
        colorMap=colorTabCurent.baseColorMap

        minZ=self.__curentRasterGrid.MinZ
        maxZ=self.__curentRasterGrid.MaxZ
        newColorTable = ColorTable(colorMap,minZ,maxZ )
        dlg_detailePalette= DlgColorGridGdal(minZ,maxZ,axipy.app.mainwindow.qt_object())
        dlg_detailePalette.setColorTable(newColorTable)
        is_ok = dlg_detailePalette.exec_()
        is_ok=dlg_detailePalette.isOk
        if is_ok:
            self.__curentRasterGrid.updateColorTable(dlg_detailePalette.colorTable)
    def __setEnableRun(self,value):
        self.ui.pb_run.setEnabled(value)
        if value:
            return
        if self.__curentRasterGrid.existPalette:
            ''' Растр имеет палитру '''
            self.ui.ln_vrt_file.setText("")
            self.ui.ln_tab_file.setText("")
            self.ui.gb_add_param.setEnabled(False)

            return
        name_tab_color,base_regular_color=gridColorChildeExist(self.__curentRasterGrid,self.__list_color_grid)
        if name_tab_color is None:
            self.ui.ln_vrt_file.setText("")
            self.ui.ln_tab_file.setText("")
            self.ui.gb_add_param.setEnabled(False)
            return
        self.ui.gb_add_param.setEnabled(True)
        self.ui.ch__rewrite_color.setChecked(True)

        self.ui.ln_vrt_file.setText(base_regular_color)
        self.ui.ln_tab_file.setText(name_tab_color)


    @property
    def widget(self):
        return self.ui
    def show(self):
        #self.ui.showMaximized()
        #print("Show Form")
        self.ui.show()