import inspect
import os

from PySide2.QtCore import QFile
from PySide2.QtGui import QDoubleValidator
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog, QColorDialog


class DlgChangeColorValue(QDialog):
    __color=None
    __str_value=None
    __dlg_ok=False
    __change_color=False
    __change_value=False
    __low_value=None
    __hig_value=None
    def __init__(self,color,str_value,parent=None):
        super().__init__(parent)
        self.__parent = parent
        self.load_ui("DlgChangeValColor.ui")

        self.__color=color
        self.__str_value=str_value
        cwd = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
        #self.__ui = loadUi(os.path.join(cwd, "DlgChangeValColor.ui"), self)
        self.__ui.pb_ok.clicked.connect(self.__okButton)
        self.__ui.pb_Cancel.clicked.connect(self.__CancelButton)
        self.__ui.pb_Color.clicked.connect(self.__changeColor)
        self.__ui.ln_Value.setValidator(QDoubleValidator())
        self.__ui.ln_Value.textChanged.connect(self.__changeLevel)
        if self.__color is not None:
            self.__setColor(self.__color)
    def load_ui(self,name_ui):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), name_ui)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.__ui  = loader.load(ui_file,self.__parent)
        ui_file.close()
        return self.__ui
    def setColorAndValue(self,color,value,str_val_low,str_val_high,isEnableRecalc):
        if str_val_low is not None:
            self.__low_value=float(str_val_low)
        if str_val_high is not None:
            self.__hig_value=float(str_val_high)
        if (str_val_low is not None) or (str_val_high is not None):
            self.__ui.lbl_warning.setText(self.__genWarning())
        self.__color=color
        self.__str_value=value
        self.__setColor(color)
        self.__setValue(value)
        self.__ui.ch_recalc_proc.setEnabled(isEnableRecalc)
        self.__ui.pb_ok.setEnabled(False)
        self.__change_color=False
        self.__change_value=False
    @property
    def IsOk(self):
        return self.__dlg_ok
    @property
    def Color(self):
        return self.__color,self.__change_color
    @property
    def Value(self):
        return self.__str_value,self.__change_value
    @property
    def bRecalProc(self):
        return self.__ui.ch_recalc_proc.isChecked()
    def __okButton(self):
        self.__dlg_ok=True
        self.__ui.close()
    def __CancelButton(self):
        self.__dlg_ok=False
        self.__ui.close()
    def __setColor(self,color):
        self.__ui.pb_Color.setStyleSheet("QWidget { background-color: %s}" % color.name())
    def __setValue(self,value):
        self.__ui.ln_Value.setText(str(value))
    def __changeColor(self):
        col = QColorDialog.getColor(self.__color, self)
        if col.isValid():
            if col.name()!=self.__color.name():
                self.__color=col
                self.__setColor(col)
                self.__ui.pb_ok.setEnabled(True)
                self.__change_color=True


    def __genWarning(self):
        result="Значение уровня должно: "
        if (self.__low_value is not None) and (self.__hig_value is not None):
            result=result+">="+str(self.__low_value)+" и <="+str(self.__hig_value)
            return result
        if self.__low_value is not None:
            result=result+">="+str(self.__low_value)
            return result
        if self.__hig_value_value is not None:
            result=result+"<="+str(self.__hig_value)
            return result
    def __changeLevel(self):
        str_txt=self.__ui.ln_Value.text()
        color = '#c4df9b' # green
        try:
            inNumberfloat = float(str_txt)
            if str_txt!=self.__str_value:
                self.__ui.pb_ok.setEnabled(True)
                self.__str_value=str_txt
                self.__change_value=True
        except ValueError:
            color = '#f6989d' # red
        sender = self.sender()
        #validator = sender.validator()
        #state = validator.validate(sender.text(), 0)[0]
        #if state == QValidator.Acceptable:
         #   color = '#c4df9b' # green
        #elif state == QValidator.Intermediate:
        #    color = '#fff79a' # yellow
        #else:
        #    color = '#f6989d' # red
        sender.setStyleSheet('QLineEdit { background-color: %s }' % color)
    def show(self):
        self.__ui.show()
    def exec_(self):
        self.show()
        self.__ui.exec_()