import inspect
import os
from PyQt5.QtGui import QPainter, QColor, QPen, QPixmap
from PyQt5.QtGui import QIcon
from PyQt5.QtCore import Qt

from PyQt5.QtGui import QPainter, QColor
from PyQt5.QtWidgets import QDialog, QWidget, QListWidgetItem, QFileDialog
from PyQt5.uic import loadUi

from RasterGridTool.toolprocessing.grid_io.ColorTable import ItemColorMap, ColorTable, createDefColorMap, ColorMap


#from AxiomaRaster.gridtools.ColorTable import ColorTable, createDefColorMap, ColorMap, ItemColorMap


class PaintWidget(QWidget):
    def setColorTab(self,colorMap):
        self.__colorMap=colorMap
        self.__colorTab=None
    def updateColor(self,color,index):
        if self.__colorMap is not None:
            self.__colorMap.ColorItems[index].setColor(color)
    def updateValue(self,value,index):
        if self.__colorMap is not None:
            self.__colorMap.ColorItems[index].setValue(value)
    def addColorItem(self,index,color,value):
        if self.__colorMap is not None:
            self.__colorMap.ColorItems.insert(index+1,ItemColorMap(value,color.red(),color.green(),color.blue()))
    def deleteColorItem(self,index):
        if self.__colorMap is not None:
            item=self.__colorMap.ColorItems.pop(index)
            item=None

    def paintEvent(self, event):
        #print("update")
        qp = QPainter(self)

      #qp.setPen(QColor.black)
        size = self.size()
        self.__colorTab=None
        self.__colorTab=ColorTable(self.__colorMap)
        height=size.height()
        width=size.width()
        self.__colorTab.setZminZmax(0.0,height)
        for ih in range(height):
            curent_color=self.__colorTab.getColorForZ(float(ih))
            qp.setPen(curent_color)
           # ih_reverse=height-ih-1
            qp.drawLine(0,ih,width,ih)
        pass

class DlgColorGridGdal(QDialog):
    __DefColorMap=None
    __dlgChangeColorValue=None
    __isOkDlg=False
    def __init__(self,zmin_grid,zmax_grid, parent=None):
        super().__init__(parent)
        cwd = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
        self.__ui = loadUi(os.path.join(cwd, "DlgColorGrid.ui"), self)
        self.__ui.pb_LoadColor.clicked.connect(self.__loadClr)
        self.__ui.pb_add.clicked.connect(self.__AddValue)
        self.__DefColorMap=createDefColorMap()
        self.__zmin=zmin_grid
        self.__zmax=zmax_grid
        self.__colorTab=ColorTable(self.__DefColorMap)
        self.__colorTab.setZminZmax(self.__zmin,self.__zmax)
        self.m = PaintWidget(self)
        self.m.setColorTab(createDefColorMap())
        self.m.move(0,0)
        self.width=self.__ui.verticalLayoutWidget.width
        self.height==self.__ui.verticalLayoutWidget.height

        self.__ui.verticalLayout.addWidget(self.m)
        self.__fillListColor()
        self.__ui.listViewColorInterval.itemDoubleClicked.connect(self.__color_item_click)
        self.__ui.listViewColorInterval.clicked.connect(self.__color_item_sel)
        self.__ui.pb_del.clicked.connect(self.__del_item_sel)
        self.__ui.pb_create_pal.clicked.connect(self.__create_new_pal)
        self.__ui.pb_Save.clicked.connect(self.__save_pal)
        self.__ui.pb_ok.clicked.connect(self.__OkButtom)
        self.__ui.pb_Cancel.clicked.connect(self.__CancelButtom)
        #self.m.resize(self.width,self.height)
    @property
    def isOk(self):
        return self.__isOkDlg
    def ColorTab(self):
        return self.__colorTab
    def __OkButtom(self):
        self.__isOkDlg=True
        self.close()
    def __CancelButtom(self):
        self.__isOkDlg=False
        self.close()
    def __fillListColor(self):
        listColorValue=self.__colorTab.listValueColor()
        for colorItem in listColorValue:
            item_lst=self.__createItemList(colorItem['color'],colorItem['value'])
            self.__ui.listViewColorInterval.addItem(item_lst)
        self.__ui.listViewColorInterval.setCurrentRow(0)
    def __createItemList(self,color_item,value):
        pixmap = QPixmap(20, 20)
        pixmap.fill(color_item)
        icon=QIcon()
        icon.addPixmap(pixmap)
        return QListWidgetItem(icon,str(value))
    def __createIcon(self,color):
        pixmap = QPixmap(20, 20)
        pixmap.fill(color)
        icon=QIcon()
        icon.addPixmap(pixmap)
        return icon
    def __loadClr(self):
        pathBase=os.path.realpath(__file__)
        pathFolderDefColorPallet=os.path.join(os.path.dirname(pathBase), "ColorPalettes")
        ext_file='*.'+'clr'
        name_load_file= QFileDialog.getOpenFileName(self, 'Загрузить палитру', pathFolderDefColorPallet, ext_file)
        if name_load_file is None:
            return
        self.__DefColorMap=None
        self.__DefColorMap=ColorMap(name_load_file[0])
        #self.__colorTab=None
        self.__colorTab=ColorTable(self.__DefColorMap)
        self.__colorTab.setZminZmax(self.__zmin,self.__zmax)
        self.__ui.listViewColorInterval.clear()
        self.__fillListColor()
        #self.m.setColorTab(ColorMap(name_load_file[0]))
    def __color_item_click(self,item):
        #sel_index=item.row()
        row = self.listViewColorInterval.currentRow()
        sel_index=row
        listColorValue=self.__colorTab.listValueColor()
        color=listColorValue[sel_index]['color']
        str_value=listColorValue[sel_index]['value']
        if self.__dlgChangeColorValue is None:
            #self.__dlgChangeColorValue=DlgChangeColorValue(None,None,self)
            pass
        low_val=str(listColorValue[sel_index]['value'])
        hig_val=str(listColorValue[sel_index]['value'])
        bIsEnableRecalc=False
        if (sel_index>0) and (sel_index<(len(listColorValue)-1)):
            low_val=str(listColorValue[sel_index-1]['value'])
            hig_val=str(listColorValue[sel_index+1]['value'])
        if sel_index==(len(listColorValue)-1):
            low_val=str(listColorValue[sel_index-1]['value'])
            bIsEnableRecalc=True
        if sel_index==0:
            hig_val=str(listColorValue[sel_index+1]['value'])
            bIsEnableRecalc=True

        self.__dlgChangeColorValue.setColorAndValue(color,str_value,low_val,hig_val,bIsEnableRecalc)
        self.__dlgChangeColorValue.exec()
        bIsOk=self.__dlgChangeColorValue.IsOk
        if not bIsOk:
            return
        new_color,is_change_color=self.__dlgChangeColorValue.Color
        new_value,is_change_value=self.__dlgChangeColorValue.Value
        bRecalcProc=False
        if bIsEnableRecalc:
            bRecalcProc=self.__dlgChangeColorValue.bRecalProc
        if is_change_color and (not is_change_value):
            # изменен только цвет
            self.__updateColor(is_change_color,sel_index,new_color)
            #new_icon=self.__createIcon(new_color)
            #item_sel=self.__ui.listViewColorInterval.item(sel_index)
            #self.__ui.listViewColorInterval.item(sel_index).setIcon(new_icon)
            #self.m.updateColor(new_color,sel_index)
        if is_change_value:
            flt_value=float(new_value)
            #pr_val=self.__colorTab.getValueInProcent(flt_value)
            count_values=len(listColorValue)
            if sel_index==0:
                next_value=listColorValue[sel_index]['value']
                if flt_value<next_value:
                    # update value index 0
                    # пока не расширяем динамический дипозон
                    #self.m.updateValue(0.0,sel_index)
                    #self.__ui.listViewColorInterval.item(sel_index).setText(str(flt_value))
                    if not bRecalcProc:
                        self.__updateValue(sel_index,flt_value)
                        self.__updateColor(is_change_color,sel_index,new_color)
                    else:
                        temp_zmin,temp_zmax=self.__colorTab.ZminZmax
                        self.__colorTab.setZminZmax(flt_value,temp_zmax)
                        self.__ui.listViewColorInterval.clear()
                        self.__fillListColor()
                    return
                else:
                    self.__resortColor(sel_index,new_color,new_value)
            if sel_index==(count_values-1):
                pre_value=listColorValue[sel_index-1]['value']
                if flt_value>pre_value:

                    if not bRecalcProc:
                        self.__updateValue(sel_index,flt_value)
                        self.__updateColor(is_change_color,sel_index,new_color)
                        self.__resortColor(sel_index,new_color,new_value)
                    else:
                        temp_zmin,temp_zmax=self.__colorTab.ZminZmax
                        self.__colorTab.setZminZmax(temp_zmin,flt_value)
                        self.__ui.listViewColorInterval.clear()
                        self.__fillListColor()

                return
            pre_value=listColorValue[sel_index-1]['value']
            next_value=listColorValue[sel_index+1]['value']
            if flt_value>pre_value and flt_value<next_value:
                pr_val=self.__colorTab.getValueInProcent(flt_value)
                self.m.updateValue(pr_val,sel_index)
                #self.__ui.listViewColorInterval.item(sel_index).setText(str(flt_value))
                self.__updateValue(sel_index,flt_value)
                self.__updateColor(is_change_color,sel_index,new_color)
            else:
                self.__resortColor(sel_index,new_color,new_value)
        pass
    def __resortColor(self,sel_index,color,value):
        pass
    def __updateValue(self,index,value):
        self.__ui.listViewColorInterval.item(index).setText(str(value))
        self.__colorTab.updateValue(index,value)
    def __updateColor(self,is_update,index,new_color):
        if is_update:
            # изменен цвет
            new_icon=self.__createIcon(new_color)
            item_sel=self.__ui.listViewColorInterval.item(index)
            self.__ui.listViewColorInterval.item(index).setIcon(new_icon)
            self.m.updateColor(new_color,index)
            self.__colorTab.updateColor(index,new_color)
    def __AddValue(self):
        listColorValue=self.__colorTab.listValueColor()
        sel_index = self.listViewColorInterval.currentRow()
        if self.__dlgChangeColorValue is None:
            #self.__dlgChangeColorValue=DlgChangeColorValue(None,None,self)
            pass
        color=listColorValue[sel_index]['color']
        str_value=listColorValue[sel_index]['value']
        low_val=str(listColorValue[sel_index]['value'])
        hig_val=str(listColorValue[sel_index]['value'])
        if (sel_index>0) and (sel_index<(len(listColorValue)-1)):
            low_val=str(listColorValue[sel_index]['value'])
            hig_val=str(listColorValue[sel_index+1]['value'])
            new_value=(listColorValue[sel_index+1]['value']-listColorValue[sel_index]['value'])/2.0+listColorValue[sel_index]['value']
            color=self.__colorTab.getColorForZ(new_value)
        if sel_index==(len(listColorValue)-1):
            low_val=str(listColorValue[sel_index-1]['value'])
            new_value=(listColorValue[sel_index]['value']-listColorValue[sel_index-1]['value'])/2.0+listColorValue[sel_index-1]['value']
            color=self.__colorTab.getColorForZ(new_value)
        if sel_index==0:
            hig_val=str(listColorValue[sel_index+1]['value'])
            new_value=(listColorValue[sel_index+1]['value']-listColorValue[sel_index]['value'])/2.0+listColorValue[sel_index]['value']
            color=self.__colorTab.getColorForZ(new_value)
        str_value=str(new_value)

        self.__dlgChangeColorValue.setColorAndValue(color,str_value,low_val,hig_val,True)
        self.__dlgChangeColorValue.exec()
        bIsOk=self.__dlgChangeColorValue.IsOk
        if not bIsOk:
            return
        new_color,is_change_color=self.__dlgChangeColorValue.Color
        new_value,is_change_value=self.__dlgChangeColorValue.Value
        new_icon_color=self.__createIcon(new_color)
        new_item=QListWidgetItem(new_icon_color,new_value)
        if sel_index==(len(listColorValue)-1):
            pass
        else:
            self.listViewColorInterval.insertItem(sel_index+1,new_item)
            self.__colorTab.addColor(sel_index+1,new_value,new_color)
            pr_value=self.__colorTab.getValueInProcent(float(new_value))
            self.m.addColorItem(sel_index,new_color,pr_value)
            self.m.update()
    def __color_item_sel(self):
        sel_index = self.listViewColorInterval.currentRow()
        if sel_index==(self.listViewColorInterval.count()-1):
            self.__ui.pb_add.setEnabled(False)
        else:
            self.__ui.pb_add.setEnabled(True)
    def __del_item_sel(self):
        sel_index = self.listViewColorInterval.currentRow()
        item=self.listViewColorInterval.takeItem(sel_index)
        item=None
        item=self.__colorTab.deleteItem(sel_index)
        item=None
        self.m.deleteColorItem(sel_index)
        self.m.update()
    def __save_pal(self):
        ext_file='*.clr'
        pathBase=os.path.realpath(__file__)
        pathFolderDefColorPallet=os.path.join(os.path.dirname(pathBase), "ColorPalettes")
        name_save_file= QFileDialog.getSaveFileName(self, 'Сохранить палитру', pathFolderDefColorPallet, ext_file)
        if name_save_file:
            is_ok=self.__colorTab.SavePal(name_save_file[0])
    def __create_new_pal(self):
        listColorValue=self.__colorTab.listValueColor()
        color_start=listColorValue[0]['color']
        count=len(listColorValue)
        color_end=listColorValue[count-1]['color']
        #dlg_new_pal=DlgNewPalette(color_start,self.__zmin,color_end,self.__zmax,self)
        #dlg_new_pal.exec()
        #is_ok_dlg=dlg_new_pal.isOk
        dlg_new_pal=None
        is_ok_dlg=False
        if is_ok_dlg:
            min_value,min_color,max_value,max_color,count=dlg_new_pal.params
            new_ColorMap=ColorMap(None)
            new_ColorMap.createFromValue(0.0,min_color,100.0,max_color,count)
            self.m.setColorTab(new_ColorMap)
            self.m.update()
            self.__zmin=min_value
            self.__zmax=max_value
            self.__colorTab=None
            self.__colorTab=ColorTable(new_ColorMap)
            self.__colorTab.setZminZmax(self.__zmin,self.__zmax)
            self.__ui.listViewColorInterval.clear()
            self.__fillListColor()
            pass
