import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget

def floatLocal(str_value:str):
    val_str=str_value.replace(",",".")
    return float(val_str)
class SlopeWidget(QWidget):
    def __init__(self,parent=None):
        super(SlopeWidget, self).__init__(parent)
        self.__parentWin=parent
        self.__loadUI()
    def __loadUI(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "Slope.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window = loader.load(ui_file, self.__parentWin)
        ui_file.close()
    def getParams(self):
        params={}
        val_str=self.window.ln_edit_scale.text().replace(",",".")
        params['scale']=val_str
        format_slope='degree'
        if self.window.cm_units.currentIndex()>0:
            format_slope='percent'
        params['slopeformat']=format_slope

        if self.window.cm_alg.currentIndex()==0:
            params['alg']='Horn'
        else:
            params['alg']='ZevenbergenThorne'
        if self.window.ch_edge.isChecked():
            params['computeEdges']=True
        else:
            params['computeEdges']=False
        return params


