import time
from pathlib import Path

from PySide2.QtCore import QObject, Signal
from osgeo import gdal


def createDEMProcessingOptions(type_proces,call_back,params):
    if type_proces==0:
        ''' Aspect'''
        obj_Options=gdal.DEMProcessingOptions(computeEdges=params['computeEdges'],alg=params['alg'],band=params['band'],scale=params['scale'],trigonometric=params['trigonometric'],zeroForFlat=params['zeroForFlat'],format=params['format'],callback=call_back)

        return obj_Options,'aspect'
    obj_Options=gdal.DEMProcessingOptions(computeEdges=params['computeEdges'],alg=params['alg'],band=params['band'],scale=params['scale'],slopeFormat=params['slopeformat'],format=params['format'],callback=call_back)

    return obj_Options,'slope'
class AspectSlope(QObject):
    updateProcess = Signal(float)
    updateFormatProgressBar=Signal(str)
    finished = Signal(int)
    def __init__(self,name_prosess,parent_class=None):
        self.__name_process=name_prosess

        super(AspectSlope, self).__init__()
        self.__parent=parent_class
        self.__erorr_message=None
        self.__cancelProcess=False
    def __process_callback(self,complete, message=None, user_data=None):
        #print('progress: {}, message: "{}", unknown {}'.format(complete, message,user_data))
        if self.__cancelProcess:
            return 0
        self.updateProcess.emit(complete*100)
        time.sleep(0.001)
        #self.__parent.window.pr_bar.setValue(complete*100)
        #print(complete*100)
        return 1
    def setCancel(self):
        self.__cancelProcess=True
    def __isCancel(self):
        self.__cancelProcess=True
    @property
    def isCancel(self):
        return self.__cancelProcess
    def setParametrs(self,path_source,path_out,typr_process,params):
        self.__path_source=path_source
        self.__path_dest=path_out
        self.__type_process=typr_process
        self.__params=params
    def run(self):
        self.__status_process=False
        self.__tab=[0]
        try:
            self.__parent.disconnect(self.__isCancel)
        except:
            pass
        self.__parent.cancelProcess.connect(self.__isCancel)
        self.__params['format']="GTiff"
        #self.__params['callback']=self.__process_callback
        ds_source=gdal.Open(self.__path_source)
        if ds_source is None:
            self.finished.emit(0)
            self.__erorr_message="Ошибка открытия исходного файла "+self.__path_source
            return
        self.__cancelProcess=False
        optDemProcess,name_process=createDEMProcessingOptions(self.__type_process,self.__process_callback,self.__params)

        gdal.DEMProcessing(destName=self.__path_dest,srcDS=ds_source,processing=name_process,options=optDemProcess)
        ds_source=None

        self.finished.emit(100)
        self.__erorr_message=None
        return
    def setCancel(self):
        self.__cancelProcess=True
    def __isCancel(self):
        self.__cancelProcess=True
    @property
    def outPath(self):
        if Path(self.__path_dest).exists():
            return self.__path_dest
        return None