import time

import axipy
from axipy import Table, Layer


def getBoundObjectsTabSql(name_tab):
    sql="Select Min(MbrMinX(FromAxiGeo(obj))) as xmin,Max(MbrMaxX(FromAxiGeo(obj))) as xmax,Min(MbrMinY(FromAxiGeo(obj))) as ymin,Max(MbrMaxY(FromAxiGeo(obj))) as ymax from "+name_tab
    start = time.time()
    tab_result=axipy.app.mainwindow.catalog.query_hidden(sql)
    fts=tab_result.items()
    bound={}
    for ft in fts:
        bound['min_x']=ft.get('xmin')
        bound['min_y']=ft.get('ymin')
        bound['max_x']=ft.get('xmax')
        bound['max_y']=ft.get('ymax')
    tab_result.close()
    end=time.time()
    print("time delta sql bound="+str(end-start))
    return bound
def getBoundObjectsTab(tab):
    bounds=None
    try:
        layer=Layer.create(tab)
        bound=layer.bounds

        bounds={}

        bounds['min_x']=bound.xmin
        bounds['min_y']=bound.ymin
        bounds['max_x']=bound.xmax
        bounds['max_y']=bound.ymax
        layer=None
    except:
        pass
    return bounds
def listNumericField(tab:Table):
    schema_tab=tab.schema
    num_field=[]
    for item in schema_tab:
        if item.typedef=='double' or item.typedef=='int' or item.typedef=='integer' or (item.typedef.find("decimal")>=0):
            num_field.append(item.name)
    if len(num_field)==0:
        return None
    return num_field
class CatalogVectorTabForGrid:
    def __init__(self):
        self.__list_tab=[]
    def update(self,list_tab):
        for tab in list_tab:
            tab_exist=list(filter(lambda obj_tab: obj_tab['name'] == tab.name, self.__list_tab))
            if len(tab_exist)>0:
                continue
            obj_tab={}
            obj_tab['name']=tab.name
            obj_tab['tab']=tab
            obj_tab['list_numeric_field']=listNumericField(tab)
            obj_tab['bound']=None
            self.__list_tab.append(obj_tab)
        for tab_obj in self.__list_tab:
            name=tab_obj['name']
            tab_exist=list(filter(lambda tab: tab.name == name, list_tab))
            jkl=0

    def getObjectTableForGrid(self,name):
        if len(self.__list_tab)==0:
            return None
        tab_exist=list(filter(lambda obj_tab: obj_tab['name'] == name, self.__list_tab))
        if len(tab_exist)==0:
            return None
        obj_tab=tab_exist[0]
        if obj_tab['bound'] is None:
            obj_tab['bound']= getBoundObjectsTab(obj_tab['tab'])

        return obj_tab




