''' Получаем список всех таблиц с регулярным гридом '''
from pathlib import Path

import axipy

from RasterGridTool.toolprocessing.grid_io.GdalSource import RasterSource
from RasterGridTool.toolprocessing.grid_io.VrtGridColorNewPalette import RasterGrid


#from RasterGridTool.toolprocessing.grid_io.VrtGridColor import RasterGrid

def getValueFromDict(source_dict,key):
    keyExist= key in source_dict
    if not keyExist :
        return None
    return source_dict[key]
def getListGridTab():
    ''' Список таблиц которые содрежат  регулярный грид'''
    def isRaster(obj):
        if not isinstance(obj, axipy.Raster):
            return False
        return True
    rasters = list(filter(isRaster, axipy.da.data_manager.objects))
    if len(rasters)==0:
        return None
    list_grid=[]
    for rast_tab in rasters:
        try:
            raster_file=None
            #raster_file=rast_tab.properties['tabFileData']['linkFile']
            value_tab_file=getValueFromDict(rast_tab.properties,'tabFileData')
            if value_tab_file is not None:
                raster_file=getValueFromDict(value_tab_file,'linkFile')
            if raster_file is None:
                raster_file=getValueFromDict(rast_tab.properties,'fileName')
                if raster_file is None:
                    continue
            gd_grid=RasterSource()
            gd_grid.OpenRead(raster_file)
            if gd_grid.isGrid:
                gd_grid.close()
                list_grid.append(rast_tab)

            gd_grid.close()
        except:
            continue
    if len(list_grid)==0:
        return None
    return list_grid
def getGridColor(listGrid):
    list_color_grid=[]
    for raster_axi in listGrid:
        try:
            raster_grid=RasterGrid(raster_axi)
            if raster_grid.existPalette:
                list_color_grid.append(raster_grid)
        except:
            continue
    return list_color_grid
def findGridTabByName(name_tab):
    list_grid=getListGridTab()
    if list_grid is None:
        return None
    for tab in list_grid:
        if tab.name==name_tab:
            return tab
    return None
def RasterIsOpen(path_raster):
    def isRaster(obj):
        if not isinstance(obj, axipy.Raster):
            return False
        return True
    rasters = list(filter(isRaster, axipy.da.data_manager.objects))
    if len(rasters)==0:
        return None
    base_path_raster=str(Path(path_raster))
    for tab_rast in rasters:
        path_raster_tab=str(Path(tab_rast.properties['fileName']))
        if base_path_raster==path_raster_tab:
            return tab_rast
    return None