import os

from PySide2.QtGui import QIcon
from axipy import view_manager

from RasterGridTool.toolprocessing.Utils.helper_observer import factoryGridObserver, factoryVectorGridObserver
from RasterGridTool.toolprocessing.ui.docWidget import AxiDocWidget, addDoc, existDocWidget, DelDocWidget
from RasterGridTool.toolprocessing.ui.viewshade.formViewShade import FormViewShade


class CalcViewShade:
    __name = 'Расчет зон видимостей'
    __name_observer_grid = 'GridAxi'
    __name_observer = "VectorGrid"
    __type_observer = "catalog"
    __form_tool = None
    __docWidget = None
    __def_name_group = "Инструменты"

    def __init__(self, parentPlugin):
        self._initTool(parentPlugin)

    def _initTool(self, parentPlugin):
        #self.__observer = factoryGridObserver(self.__name_observer)
        self.__observer =factoryVectorGridObserver(self.__name_observer, self.__name_observer_grid)
        self.__observer.changed.connect(self.__changeValueObserver)
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'viewshed_32x32.png')
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'SlopeV1_32x32.png')
        try:
            self.__action = parentPlugin.create_action(self.__name, icon=local_file_icon, on_click=self.__run,enable_on=self.__name_observer)
        except Exception as ex:
            jkl = 0
        return
    def __changeValueObserver(self):
        value_observer=self.__observer.value
        if not value_observer:
            if self.__docWidget is not None:
                DelDocWidget(view_manager.global_parent,self.__docWidget)
                #self.__observer.removeChildrenWidget(self.__name_observer)

                self.__docWidget=None
                self.__form_tool=None
                return
        if self.__docWidget is not None:

            self.__form_tool=FormViewShade(view_manager.global_parent)
            self.__form_tool.updateSource()
            #self.__form_tool.updatTable()
            #self.__observer.addChildrenWidget(self.__name_observer,self.__form_tool)
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"ViewShade",self.__name,QIcon(),view_manager.global_parent)
            addDoc(view_manager.global_parent,self.__docWidget)
    def __run(self):
        if self.__form_tool is None:

            self.__form_tool=FormViewShade(view_manager.global_parent)
            self.__form_tool.updateSource()
            #self.__form_tool.updatTable()
            #self.__observer.addChildrenWidget("CalcSlope",self.__form_tool)
        if self.__docWidget is None:

            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"ViewShade",self.__name,QIcon(),view_manager.global_parent)
            addDoc(view_manager.global_parent,self.__docWidget)
        else:
            isExist=existDocWidget(view_manager.global_parent,self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    @property
    def name(self):
        return self.__name

    @property
    def name_group(self):
        return self.__def_name_group

    @property
    def action(self):
        return self.__action

    @property
    def nameObserver(self):
        return self.__name_observer

    @property
    def typeObserver(self):
        return self.__type_observer

    @property
    def docWidget(self):
        return self.__docWidget

    @property
    def form(self):
        return self.__form_tool