import axipy
from axipy import Polygon, Pnt
from osgeo import gdal, ogr, osr

#from .vectorTool import TempVector


def getCoordSysCosmeticTab(name_tab):
    maps= axipy.gui.view_manager.mapviews
    for map_view in maps:
        map=map_view.map
        cosmetic_layer=map.cosmetic
        tab_cosmo=cosmetic_layer.data_object
        if tab_cosmo.name==name_tab:
            return map_view.coordsystem
    return None
def AxiGpcToGdal(axiGpc):
    gpcs=[]
    for i,reg_opint in enumerate(axiGpc):
        raster_point=reg_opint.device
        geo_point=reg_opint.scene
        id_point=i+1
        gpcs.append(gdal.GCP(geo_point[0],geo_point[1],0,raster_point[0],raster_point[1],'point'+str(id_point),'pt'+str(id_point)))
    return gpcs
def AxiTransformToGeoTransform(axi_transform):
    gdal_geo_transfrom=(axi_transform.dx(),axi_transform.m11(),0.0,axi_transform.dy(),0.0,axi_transform.m22())
    return gdal_geo_transfrom
def createBoundRaster(raster_tab):
    size_raster=raster_tab.size
    width=size_raster.width()
    height=size_raster.height()
    #tr=raster_tab.device_to_scene_transform
    list_bound_pts=[]
    tr_0=raster_tab.device_to_scene_transform.translate(0,0)
    list_bound_pts.append(Pnt(tr_0.dx(),tr_0.dy()))
    tr_0=raster_tab.device_to_scene_transform.translate(0,height-1)
    list_bound_pts.append(Pnt(tr_0.dx(),tr_0.dy()))
    tr_0=raster_tab.device_to_scene_transform.translate(width-1,height-1)
    list_bound_pts.append(Pnt(tr_0.dx(),tr_0.dy()))
    tr_0=raster_tab.device_to_scene_transform.translate(width-1,0)
    list_bound_pts.append(Pnt(tr_0.dx(),tr_0.dy()))
    poly_bound=Polygon(list_bound_pts,cs=raster_tab.coordsystem)
    return poly_bound
class OgrVector:
    def __init__(self,path_shp,cs_proj4):
        self.__id_curent=0
        self.__path_file=path_shp
        self.__createShp(path_shp,cs_proj4)
    def __createShp(self,path_shp,cs_proj4):
        driver_shp=ogr.GetDriverByName('ESRI Shapefile')
        self.__ds = driver_shp.CreateDataSource(path_shp)
        if self.__ds is None:
            return False
        srs =  osr.SpatialReference()
        srs.ImportFromProj4(cs_proj4)
        self.__layer = self.__ds.CreateLayer("cutline", srs, ogr.wkbPolygon)
        idField = ogr.FieldDefn("id", ogr.OFTInteger)
        self.__layer.CreateField(idField)
        self.__featureDefn=self.__layer.GetLayerDefn()
        return True

    def addListGeometry(self, list_geo):
        for geo in list_geo:
            self.addGeometry(geo)

    def addGeometry(self, geo_axi):
        if isinstance(geo_axi, list):
            return self.addListGeometry(geo_axi)
        geometry = ogr.CreateGeometryFromWkb(geo_axi.to_wkb())
        self.__id_curent = self.__id_curent + 1

        feature = ogr.Feature(self.__featureDefn)
        feature.SetGeometry(geometry)
        feature.SetField("id", self.__id_curent)
        self.__layer.CreateFeature(feature)
        geometry = None
        feature = None
    def close(self):
        self.__layer=None
        self.__ds=None
def createTempShpFromRaster(name_table):
    ''' Создание временного shp с bound растра'''
    tab_file=axipy.data_manager.find(name_table)
    bound_poly=createBoundRaster(tab_file)
    from .vectorTool import TempVector
    temp_shp=TempVector()
    temp_shp.create(tab_file.coordsystem)
    temp_shp.copy(bound_poly)
    return temp_shp





