import os

from PySide2 import QtCore
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog


class DlgAddRasterAxioma(QDialog):
    def __init__(self,parent=None):
        super(DlgAddRasterAxioma, self).__init__(parent)
        self.__parentWin=parent
        self.__loadUI()
        self.window.setWindowFlags(
            self.window.windowFlags() & ~QtCore.Qt.WindowCloseButtonHint & ~QtCore.Qt.WindowContextHelpButtonHint)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.window.pb_ok.clicked.connect(self.__ok)
        self.window.list_raster.itemSelectionChanged.connect(self.__selectItems)
    def __loadUI(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "DlgAxiomaRaster.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    def __cancel(self):
        self.__isOk=False
        self.window.close()
    def __ok(self):
        self.__isOk=True
        self.window.close()
    def __selectItems(self):
        if len(self.window.list_raster.selectedItems())>0:
            self.window.pb_ok.setEnabled(True)
        else:
            self.window.pb_ok.setEnabled(False)
    def run(self,list_table_name):
        self.window.list_raster.clear()
        for tab_name in list_table_name:
            self.window.list_raster.addItem(tab_name)
        self.window.exec()
        if not self.__isOk:
            return None
        select_tables=[]
        for item in self.window.list_raster.selectedItems():
          select_tables.append(item.text())
        return select_tables