import os

from datetime import date, datetime
from pathlib import Path

import axipy
from PySide2 import QtCore
from PySide2.QtCore import QFile, Qt
from PySide2.QtGui import QIcon
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QFileDialog, QDialog, QApplication
from axipy import Raster, provider_manager, ChooseCoordSystemDialog, TabFile, Layer, app

# from RasterGridTool.toolprocessing.Utils.Observer import factoryObserverRaster
from axipy.app import Notifications

from RasterGridTool.toolprocessing.ui.combineRaster.DlgAddAximaRaster import DlgAddRasterAxioma
from RasterGridTool.toolprocessing.ui.combineRaster.tool.addTool import RasterAxioma, RasterFromFile
from RasterGridTool.toolprocessing.ui.combineRaster.tool.combine_raster import RasterProcessCombine

'''
from AxyPy.CombineRaster.DlgAddAximaRaster import DlgAddRasterAxioma
from AxyPy.CombineRaster.tool.addTool import RasterFromFile, RasterAxioma
from AxyPy.CombineRaster.tool.combine_raster import RasterProcessCombine
'''
from RasterGridTool.toolprocessing.ui.clipRaster.tool.rasterTool import TypeInterpoly


class FormCombineRaster(QWidget):
    cancelProcess = QtCore.Signal()
    __name_observer = 'openRaster'

    def __init__(self, parent=None):
        super(FormCombineRaster, self).__init__(parent)
        self.__parentWin = parent
        self.__loadUI()
        self.__cs_out = None
        self.__path_out_files = None
        self.__process = None
        self.__last_source_folder=None
        curent_path = str(Path(__file__).parent)
        path_icon = os.path.join(curent_path, "icons")
        path_del_png = os.path.join(path_icon, "delete_32x32.png")
        self.window.pb_del.setIcon(QIcon(path_del_png))
        self.window.pb_add_axioma.setIcon(QIcon(os.path.join(path_icon, "add_16x16.png")))
        self.window.pb_add_disk.setIcon(QIcon(os.path.join(path_icon, "open_file_16.png")))
        # self.__observer=factoryObserverRaster(self.__name_observer)
        # self.__observer.changed.connect(self.__changeValueObserver)
        # self.__changeValueObserver()

        axipy.da.data_manager.added.connect(self.__add_tab)
        axipy.da.data_manager.removed.connect(self.__close_tab)
        self.window.pb_add_axioma.clicked.connect(self.__add_axioma)
        self.window.pb_del.clicked.connect(self.__delete_raster)
        self.window.pb_add_disk.clicked.connect(self.__add_raster_from_disk)
        self.window.pb_change_out_cs.clicked.connect(self.__change_out_cs)
        self.window.pb_run.clicked.connect(self.__run)
        self.window.pb_cancel.clicked.connect(self.__cancel)
        self.window.pb__select_out_file.clicked.connect(self.__change_out_path)
        self.dlg_sel_axioma = None
        self.__dlg_SelectFiles = None
        self.__list_select_raster = []
        self.__initOpenTable()
    def __loadUI(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "CombineRaster.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window = loader.load(ui_file, self.__parentWin)
        ui_file.close()

    '''
    def __changeValueObserver(self):
        value_observer=self.__observer.value()
        if value_observer:
            self.window.pb_add_axioma.setEnabled(True)
    '''
    def __initOpenTable(self):
        tables=axipy.data_manager.all_objects
        count_raster_open=0
        for tab in tables:
            if isinstance(tab, Raster) and (not self.window.pb_add_axioma.isEnabled()):
                count_raster_open=count_raster_open+1
        if count_raster_open>1:
            self.window.pb_add_axioma.setEnabled(True)
    def __add_tab(self, name_tab):
        tab = axipy.data_manager.find(name_tab)
        if isinstance(tab, Raster) and (not self.window.pb_add_axioma.isEnabled()):
            self.window.pb_add_axioma.setEnabled(True)

    def __close_tab(self, name_tab):
        try:
            tab = axipy.data_manager.find(name_tab)
            if not isinstance(tab, Raster):
                return
            '''
            all_data_obj = axipy.da.data_manager.all_objects
            tables_axioma = list(filter(lambda tab: isinstance(tab, Raster), all_data_obj))
            for tab_raster in tables_axioma:
                item = self.window.list_raster.findItems(tab_raster.name, Qt.MatchContains)
                if len(item) > 0:
                    itemIndex = self.window.list_raster.indexFromItem(item[0])
                    self.window.list_raster.takeItem(itemIndex.row())
            if self.window.list_raster.count() == 0:
                self.window.pb_del.setEnabled(False)
            '''
            item = self.window.list_raster.findItems(tab.name, Qt.MatchContains)
            if len(item) > 0:
                itemIndex = self.window.list_raster.indexFromItem(item[0])
                self.window.list_raster.takeItem(itemIndex.row())
            if self.window.list_raster.count() == 0:
                self.window.pb_del.setEnabled(False)
        except Exception as ex:
            print(ex)
            pass

    def __add_axioma(self):
        all_data_obj = axipy.da.data_manager.all_objects
        list_view_tab_axioma = []
        tables_axioma = list(filter(lambda tab: isinstance(tab, Raster), all_data_obj))
        if self.window.list_raster.count() > 0:
            ''' Ищем закрытые растры'''
            for i in range(self.window.list_raster.count()):
                item = self.window.list_raster.item(i)
                name_tab = item.text()
                list_items = list(filter(lambda tab: tab.name == name_tab, tables_axioma))
                if len(list_items) == 0:
                    continue
                dict_indices = [i for i, d in enumerate(tables_axioma) if d.name == name_tab]
                tables_axioma.pop(dict_indices[0])
            if len(tables_axioma) > 0:
                for tab in tables_axioma:
                    list_view_tab_axioma.append(tab.name)
        else:
            for rast_tab in tables_axioma:
                list_view_tab_axioma.append(rast_tab.name)
        if self.dlg_sel_axioma is None:
            self.dlg_sel_axioma = DlgAddRasterAxioma(self.__parentWin)
        if len(list_view_tab_axioma) == 0:
            return
        list_tab_axioma = self.dlg_sel_axioma.run(list_view_tab_axioma)
        if list_tab_axioma is None:
            return
        for rast_tab in list_tab_axioma:
            self.window.list_raster.addItem(rast_tab)
            tab_raster = axipy.da.data_manager.find(rast_tab)
            self.__list_select_raster.append(RasterAxioma(tab_raster))
        self.window.pb_del.setEnabled(True)
        if self.window.list_raster.count() > 0:
            self.window.pb_del.setEnabled(True)
            self.__setOutCoordSys()
        if self.window.list_raster.count() >= 2:
            self.window.pb_run.setEnabled(True)
            if self.__path_out_files is None:
                ''' формируем имя выходного фала'''
                str_cur_time = datetime.now().strftime("%Y_%m_%d %H_%M_%S")
                if self.__last_source_folder is None:
                    raster_tab=self.__list_select_raster[0]
                    self.__last_source_folder=str(Path(raster_tab.path).parent)
                self.__path_out_files = os.path.join(self.__last_source_folder,
                                                     "combine_rastr_" + str_cur_time + ".gpkg")
                self.window.out_tab_file.setText(self.__path_out_files)
                self.window.out_tab_file.setCursorPosition(0)
        else:
            self.window.pb_run.setEnabled(True)

    def __delete_raster(self):
        if len(self.window.list_raster.selectedItems()) > 0:

            for item in self.window.list_raster.selectedItems():
                itemIndex = self.window.list_raster.indexFromItem(item)
                self.window.list_raster.takeItem(itemIndex.row())
                name = item.text()
                dict_indices = [i for i, d in enumerate(self.__list_select_raster) if d.name == name]
                self.__list_select_raster.pop(dict_indices[0])
        if self.window.list_raster.count() == 0:
            self.window.pb_del.setEnabled(False)

    def __add_raster_from_disk(self):
        ''' Добавляем растры с диска '''
        ext_list = "Tab (*.tab)"
        home_directory = str(Path.home())
        if self.__dlg_SelectFiles is None:
            self.__dlg_SelectFiles = QFileDialog(self, 'Растры', home_directory, ext_list)
            name_select = self.__dlg_SelectFiles.getOpenFileNames(axipy.app.mainwindow.qt_object(), 'Растры',
                                                                  home_directory, ext_list)
        else:
            # last_folder=self.__dlg_SelectFiles.directory()
            # filter=self.__dlg_SelectFiles.filter()
            name_select = self.__dlg_SelectFiles.getOpenFileNames(dir=self.__last_source_folder, filter=ext_list)
            jkl = 0
        if len(name_select[0]) == 0:
            return
        for i, file_raster in enumerate(name_select[0]):
            if i == 0:
                self.__last_source_folder = str(Path(file_raster).parent)

            raster_disk = RasterFromFile(file_raster)
            if not raster_disk.isRaster:
                continue
            dict_indices = [i for i, d in enumerate(self.__list_select_raster) if d.name == raster_disk.name]
            if len(dict_indices) > 0:
                continue
            self.__list_select_raster.append(raster_disk)
            self.window.list_raster.addItem(raster_disk.name)
        if self.window.list_raster.count() > 0:
            self.window.pb_del.setEnabled(True)
            self.__setOutCoordSys()
        if self.window.list_raster.count() >= 2:
            self.window.pb_run.setEnabled(True)
            self.window.gr_box_out_options.setEnabled(True)
            if self.__path_out_files is None:
                ''' формируем имя выходного фала'''
                str_cur_time = datetime.now().strftime("%Y_%m_%d %H_%M_%S")
                self.__path_out_files = os.path.join(self.__last_source_folder,
                                                     "combine_rastr_" + str_cur_time + ".gpkg")
                self.window.out_tab_file.setText(self.__path_out_files)
                self.window.out_tab_file.setCursorPosition(0)
        else:
            self.window.pb_run.setEnabled(True)

    def __setOutCoordSys(self):
        if len(self.__list_select_raster) == 0:
            return
        tab_sel = self.__list_select_raster[0]

        self.__cs_out = tab_sel.coordsystem
        mi_coord_sys = self.__cs_out.name
        self.window.ln_coordSys.setText(mi_coord_sys)

    def __change_out_cs(self):
        dialog_cs = ChooseCoordSystemDialog(self.__cs_out)
        if dialog_cs.exec() == QDialog.Accepted:
            self.__cs_out = dialog_cs.chosenCoordSystem()
            self.window.ln_coordSys.setText(self.__cs_out.name)
            self.window.ln_coordSys.setCursorPosition(0)

    def __setFormatprogressBar(self, str_format):
        self.window.progres_bar.setFormat(str_format)
        import time
        time.sleep(0.0001)
        QApplication.processEvents()
    def __change_out_path(self):
        ext_list="GPKG (*.gpkg);;GeoTiff (*.tif)"
        if self.__path_out_files is None:
            out_file="*.gpkg"
        else:
            out_file=self.__path_out_files
        name_load_file = QFileDialog.getSaveFileName(axipy.app.mainwindow.qt_object(), 'Файл результата',os.path.join(self.__last_source_folder,out_file), ext_list)
        if not(name_load_file[0] ==''):
            self.window.out_tab_file.setText(name_load_file[0])
            self.window.out_tab_file.setCursorPosition(0)
    def __cancel(self):
        self.__process_status = False
        self.cancelProcess.emit()
        self.__process.setCancel()

    def __update_progress(self, value):
        self.window.progres_bar.setValue(value)
        # print(value)
        import time
        time.sleep(0.0001)
        QApplication.processEvents()

    def __run(self):
        typeAlgoritm = TypeInterpoly(self.window.cm_alg_interpol.currentIndex())
        self.__path_out_raster = self.window.out_tab_file.text()
        if self.__process is None:
            self.__process = RasterProcessCombine("Объединение растров", self)
            self.__process.updateProcess.connect(self.__update_progress)
            self.__process.finished.connect(self.__end_process)
            self.__process.updateFormatProgressBar.connect(self.__setFormatprogressBar)
        out_options={"tile":self.window.chb_tiles.isChecked() and self.window.chb_tiles.isEnabled()}
        out_options['compress']=self.window.chb_compress.isChecked() and self.window.chb_compress.isEnabled()

        self.__process.setParametrs(self.__list_select_raster, self.__cs_out.wkt, typeAlgoritm, self.__path_out_raster,out_options)
        self.window.pb_cancel.setEnabled(True)
        self.window.pb_run.setEnabled(False)
        self.__process.run()

    def __end_process(self, value):
        self.window.pb_cancel.setEnabled(False)
        self.window.pb_run.setEnabled(True)
        if value == 100:
            tab_mosaic = provider_manager.gdal.open(self.__path_out_raster)
            tab = TabFile()
            out_file_name = os.path.join(str(Path(self.__path_out_raster).parent),
                                         str(Path(self.__path_out_raster).stem) + ".tab")
            tab.generate_tab(tab_mosaic, out_file_name)
            #tab_mosaic.close()
            #tab_mosaic = provider_manager.openfile(out_file_name)
            layer = Layer.create(tab_mosaic)
            app.mainwindow.add_layer_interactive(layer)

        else:
            if os.path.exists(self.__path_out_raster):
                os.remove(self.__path_out_raster)
            Notifications.push('Объединение растров', 'Было преррвано', Notifications.Information)

    @property
    def widget(self):
        return self.window
