import os

from PySide2.QtCore import QFile
from PySide2.QtGui import QDoubleValidator, QIntValidator
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget



class ParamIdw(QWidget):
    def __init__(self,parent=None):
        self.__parentWin=parent
        super(ParamIdw, self).__init__(parent)
        self.load_ui()
        powerValidator=QDoubleValidator()
        powerValidator.setBottom(0.5)
        powerValidator.setTop(4.0)
        dist_search=QDoubleValidator()
        dist_search.setBottom(0.0)
        self.window.ln_power.setValidator(powerValidator)
        self.window.ln_dist_search.setValidator(dist_search)
        vl_smoth=QDoubleValidator()
        vl_smoth.setBottom(0.0)
        self.window.ln_smoth.setValidator(vl_smoth)

        vl_min_point=QIntValidator()
        vl_min_point.setBottom(0)
        self.window.ln_min_points.setValidator(vl_min_point)
        vl_max_point=QIntValidator()
        vl_max_point.setBottom(0)
        self.window.ln_max_points.setValidator(vl_min_point)
        self.window.ln_dist_search.textChanged.connect(self.__change_dist)
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "widgetIdwParams.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()
    def __change_dist(self,value):
        isEnable=False
        if value=='0' or value=='0.0' or float(value)<=0:
            isEnable=False
        else:
            isEnable=True

        self.window.ln_max_points.setEnabled(isEnable)
        self.window.ln_min_points.setEnabled(isEnable)
        self.window.ln_smoth.setEnabled(isEnable)
    @property
    def optionsGridCreate(self):
        out_options="invdist:"
        str_val_dist_search=self.window.ln_dist_search.text()
        str_power=self.window.ln_power.text()
        if str_val_dist_search=='0' or str_val_dist_search=='0.0' or float(str_val_dist_search)<=0:
            out_options=out_options+"power="+str_power+":radius1=0.0:radius2=0.0"
        else:
            out_options=out_options+"power="+str_power+":radius1="+str_val_dist_search+":radius2="+str_val_dist_search
            out_options=out_options+":angle=0.0"
            out_options=out_options+":smoothing="+self.window.ln_smoth.text()
            out_options=out_options+":min_points="+self.window.ln_min_points.text()
            out_options=out_options+":max_points="+self.window.ln_max_points.text()
        return out_options
    @property
    def nameMethod(self):
        return "IDW"



