from osgeo import ogr, gdal


class MemVectorOgr:
    def __init__(self,name_drv="GPKG"):
        self.__name_driver=name_drv
    def create(self,name,ogr_srs,type_obj=ogr.wkbMultiPolygon):
        self.__name=name
        self.__mem_path_ds= "/vsimem/"+name+'.'+self.__name_driver.lower()
        name_driver_by_ext="GPKG"
        if self.__name_driver.lower()=="shp":
            name_driver_by_ext='ESRI Shapefile'
        self.__ogr_ds = ogr.GetDriverByName(name_driver_by_ext).CreateDataSource(self.__mem_path_ds)
        self.__ogr_lyr = self.__ogr_ds.CreateLayer('contour',ogr_srs, geom_type=type_obj)
#ogr_lyr = ogr_ds.CreateLayer('contour',out_srs, geom_type=ogr.wkbLineString)
        field_defn = ogr.FieldDefn('id', ogr.OFTInteger)
        self.__ogr_lyr.CreateField(field_defn)
        field_defn = ogr.FieldDefn('level_min', ogr.OFTReal)
        self.__ogr_lyr.CreateField(field_defn)
        field_defn = ogr.FieldDefn('level_max', ogr.OFTReal)
        self.__ogr_lyr.CreateField(field_defn)
        return self.__ogr_lyr
    def close(self):
        self.__ogr_lyr=None
        self.__ogr_ds=None
        gdal.Unlink(self.__mem_path_ds)


