import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QFrame

from .VriogramDirection import VariogramDirect, TableDir


class WidgetVariogRamDirection(QWidget):
    def __init__(self,parent=None):
        self.__parentWin=parent
        super(WidgetVariogRamDirection, self).__init__(parent)
        self.load_ui()
        self.__frame=QFrame()
        self.__diagram=VariogramDirect()
        self.__tabDirection=TableDir()
        self.__tabDirection.setWidgetDiagram(self.__diagram)
        self.window.vrt_diagram.addWidget(self.__diagram)
        self.window.vert_values_tab.addWidget(self.__tabDirection.window)

    def show(self):
        self.window.show()
    def variogramDirections(self):
        return self.__tabDirection.variogramDirections()
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "VarioDirectWidget.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()


