import sys
hidepyqt = sys.modules.pop('PyQt5.QtCore', None)
import matplotlib.backends.backend_qt5agg
if hidepyqt:
    sys.modules['PyQt5.QtCore'] = hidepyqt


import axipy
from PySide2.QtWidgets import QDialog, QPushButton, QVBoxLayout
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.backends.backend_qt5agg import NavigationToolbar2QT as NavigationToolbar
import matplotlib.pyplot as plt
import random

# main window
# which inherits QDialog
class ViewVariogram(QDialog):

    # constructor
    def __init__(self, variogram_data,parent=None):
        super(ViewVariogram, self).__init__(parent)

        self.__data_vriogram=variogram_data
        # a figure instance to plot on
        self.figure = plt.figure()

        # this is the Canvas Widget that
        # displays the 'figure'it takes the
        # 'figure' instance as a parameter to __init__
        self.canvas = FigureCanvas(self.figure)

        # this is the Navigation widget
        # it takes the Canvas widget and a parent
        self.toolbar = NavigationToolbar(self.canvas, self)
        # creating a Vertical Box layout
        layout = QVBoxLayout()

        # adding tool bar to the layout
        layout.addWidget(self.toolbar)

        # adding canvas to the layout
        layout.addWidget(self.canvas)
        # setting layout to the main window
        self.setLayout(layout)
        self.__plot()
    def __plot(self):
        for item_vario in self.__data_vriogram.dataVariogram:
            angle=item_vario['direction']
            width=item_vario['width']
            str_name=str(angle)+'-'+str(width)
            data=item_vario['data']
            n=len(data)
            x=[]
            for i in range(n):
                x.append(float(i)*self.__data_vriogram.step)
            plt.plot(x,data,label=str_name)
        xmin=0
        xmax=self.__data_vriogram.step*(n-1)
        ''' Draw dispec'''
        plt.plot([xmin,xmax],[self.__data_vriogram.dispersion,self.__data_vriogram.dispersion],label="Дисперсия")

        #ax = plt.axes()
        #ax.grid(True, linestyle='-.')
        plt.legend(title='Parameter where:')
        self.canvas.draw()


