import os


from PySide2 import QtCore, QtGui
from PySide2.QtCore import QPoint, QFile
from PySide2.QtGui import QPainter, QPalette, QPen, Qt, QBrush, QColor
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QSpinBox, QCheckBox
def decartAngleToAzimut(angle):
    if angle>=0 and angle<=90:
        return 90-angle
    if angle>=90 and angle<=180:
        return 450-angle
    if angle>=180 and angle<=270:
        return 450-angle
    if angle>=270 and angle<=360:
        return 450-angle


class Direction:
    def __init__(self,angle,width,stylePen,styleBrush):
        self.__angle=decartAngleToAzimut(angle)
        self.__width=width
        self.__pen=stylePen
        self.__brush=styleBrush
    def setAngle(self,value_angle):
        self.__angle=value_angle
    def setWidthDiagram(self,value_width):
        self.__width=value_width
    @property
    def allParametrs(self):
        return self.__angle,self.__width,self.__pen,self.__brush
class TableDir(QWidget):
    def __init__(self,parent=None):
        self.__startView=True
        self.__parentWin=parent
        self.__digramView=None
        super(TableDir, self).__init__(parent)
        self.load_ui()
        self.initTableDir()
        self.__initDefaultStyle()
    def initTableDir(self):
        #self.window.tableWidget.setColumnCount(2)
        #self.window.tableWidget.setHorizontalHeaderLabels(['Направление',"Ширина"])
        self.window.tableWidget.setRowCount(4)
        self.window.tableWidget.setColumnWidth(0,20)
        self.window.tableWidget.setColumnWidth(1,60)
        self.window.tableWidget.setColumnWidth(2,60)
        '''
        self.__dir_0=QSpinBox()
        self.__dir_0.setFixedWidth(60)
        self.__dir_0.setValue(0)
        self.__dir_0.setSuffix(' °')
        self.__dir_0.adjustSize()
        self.__dir_0.setBaseSize(50, 40)
        self.__dir_0_width=QSpinBox()
        self.__dir_0_width.setValue(90)
        '''
        self.__list_rowItems=[]
        self.__list_rowItems.append(self.__get_row_obj(0,90,True))
        self.__list_rowItems.append(self.__get_row_obj(90,90,True))
        self.__list_rowItems.append(self.__get_row_obj(0,90,False))
        self.__list_rowItems.append(self.__get_row_obj(0,90,False))
        for i in range(4):
            self.__list_rowItems[i]['check'].stateChanged.connect(self.__isCheck)
            self.window.tableWidget.setCellWidget(i,0,self.__list_rowItems[i]['check'])
            self.window.tableWidget.setCellWidget(i,1,self.__list_rowItems[i]['dir'])
            self.window.tableWidget.setCellWidget(i,2,self.__list_rowItems[i]['width'])
        #r_col_0=QTableWidgetItem(self.__dir_0)
        '''
        self.window.tableWidget.setCellWidget(0,0,QCheckBox())
        self.window.tableWidget.setCellWidget(0,1,self.__dir_0)
        self.window.tableWidget.setCellWidget(0,2,self.__dir_0_width)
        '''
        '''
        self.window.tableWidget.item(0, 0).setFlags(QtCore.Qt.ItemIsUserCheckable |
                                                         QtCore.Qt.ItemIsEnabled)
        '''
        self.__isStart=True
        #self.window.tableWidget.currentCellChanged.connect(self.__changeCell)
        #self.window.tableWidget.itemClicked.connect(self.__cellClicked)
        #self.window.tableWidget.itemActivated.connect(self.__cellClicked)
        #self.window.tableWidget.setCellWidget(0,0,QCheckBox())
        self.window.tableWidget.viewport().installEventFilter(self)
    def __initDefaultStyle(self):
        self.__styleDiagrams=[]
        self.__styleDiagrams.append({'pen':QPen(Qt.red,  2, Qt.DashLine),'brush':QtGui.QBrush(QtGui.QColor(255, 0,0),QtCore.Qt.FDiagPattern)})
        self.__styleDiagrams.append({'pen':QPen(Qt.green,  2, Qt.DashLine),'brush':QtGui.QBrush(QtGui.QColor(0,255,0),QtCore.Qt.FDiagPattern)})
        self.__styleDiagrams.append({'pen':QPen(Qt.blue,  2, Qt.DashLine),'brush':QtGui.QBrush(QtGui.QColor(0,0,255),QtCore.Qt.FDiagPattern)})
        self.__styleDiagrams.append({'pen':QPen(Qt.yellow,  2, Qt.DashLine),'brush':QtGui.QBrush(QtGui.QColor(0,255,255),QtCore.Qt.FDiagPattern)})
    def setWidgetDiagram(self,widgetDiagram):
        self.__digramView=widgetDiagram
    def eventFilter(self, source, event):
        if self.__startView:
            if event.type() == QtCore.QEvent.Type.Show:
                self.__startView=False
                self.__updateDigram()
        if self.window.tableWidget.selectedIndexes() != []:
            #print(event.type())
            if event.type() == QtCore.QEvent.MouseButtonPress:
                curentRow=self.window.tableWidget.currentRow()
                #print(curentRow)
                self.__updateDigram()
                jkl=0
        return QtCore.QObject.event(source, event)
    def __get_row_obj(self,angle,width,enable):
        dir_=QSpinBox()
        dir_.setFixedWidth(60)
        dir_.setValue(angle)
        dir_.setMaximum(270)
        #dir_.setPrefix("Направление ")
        dir_.setSuffix(' °')
        dir_check=QCheckBox()
        dir_check.setChecked(enable)


        dir_width=QSpinBox()
        dir_width.setValue(width)
        dir_width.setSuffix(' °')
        dir_width.setFixedWidth(60)
        dir_width.setMaximum(180)
        if not enable:
            dir_.setEnabled(enable)
            dir_width.setEnabled(enable)

        #dir_width.setPrefix("Ширина ")
        return {'dir':dir_,'width':dir_width,"check":dir_check}
    def __isCheck(self,status):
        curentRow=self.window.tableWidget.currentRow()
        #print("Current Row:"+str(curentRow))
        if status==0:
            self.__list_rowItems[curentRow]['dir'].setEnabled(False)
            self.__list_rowItems[curentRow]['width'].setEnabled(False)
        else:
            self.__list_rowItems[curentRow]['dir'].setEnabled(True)
            self.__list_rowItems[curentRow]['width'].setEnabled(True)
        self.__updateDigram()
    def __changeCell(self,currentRow,currentColumn,previousRow,previousColumn):
        if currentColumn==0:
            '''
            if self.__isStart:
                self.__isStart=False
                return
            '''
            print(self.__list_rowItems[currentRow]['check'].isChecked())
            if self.__list_rowItems[currentRow]['check'].isChecked():
                #self.__list_rowItems[currentRow]['check'].setChecked(False)
                self.__list_rowItems[currentRow]['dir'].setEnabled(False)
                self.__list_rowItems[currentRow]['width'].setEnabled(False)

            else:
                #self.__list_rowItems[currentRow]['check'].setChecked(True)
                self.__list_rowItems[currentRow]['dir'].setEnabled(True)
                self.__list_rowItems[currentRow]['width'].setEnabled(True)
            jkl=0
    def __updateDigram(self):
        list_direction=[]
        for id,item_direction in enumerate(self.__list_rowItems):
            if item_direction['check'].isChecked():
                direction= item_direction['dir'].value()
                width_dir=item_direction['width'].value()
                list_direction.append(Direction(direction,width_dir,self.__styleDiagrams[id]['pen'],self.__styleDiagrams[id]['brush']))
        if len(list_direction)==0:
            self.__digramView.updateView(None)
        else:
            self.__digramView.updateView(list_direction)
    def __cellClicked(self, row, column):
        #print("column", column)
        self.setStyleSheet('background-color: red;')

        return column
    def variogramDirections(self):
        list_directions=[]
        for item_direction in self.__list_rowItems:
            if item_direction['check'].isChecked():
                direction= item_direction['dir'].value()
                width_dir=item_direction['width'].value()
                list_directions.append({"direction":direction,"width":width_dir})
        if len(list_directions)==0:
            return None
        return list_directions
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "FormDirection.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.window  = loader.load(ui_file,self.__parentWin)
        ui_file.close()

class VariogramDirect(QWidget):
    '''
    Ототбражение направлений расчет вариограмм
    '''
    point_otstup=4
    def __init__(self,parent=None):
        self.__directions=None
        super(VariogramDirect, self).__init__(parent)
        #self.__init_testDirection()
    def paintEvent(self, event):
        self.__painter = QPainter()
        self.__painter.begin(self)
        self.__painter.setRenderHint(QPainter.Antialiasing)

        self.__painter.fillRect(event.rect(), self.palette().brush(QPalette.Window))
        self.__draw_base()
        #self.__draw_direction_pie(0,90)
        self.__updatePieDirection()
        self.__painter.end()
    def updateView(self,list_directions):
        self.__directions=list_directions
        if list_directions is not None:
            self.update()
    def __draw_base(self):

        self.__painter.save()
        #print(str(self.width()/2)+"  "+str(self.height()/2))
        self.__painter.translate(self.width()/2, self.height()/2)
        rd=None
        if self.width()>self.height():
            rd=self.height()/2-self.point_otstup
        else:
            rd=self.width()/2-self.point_otstup
        x=self.width()/2+self.point_otstup
        y=self.height()/2+self.point_otstup
        self.__painter.setPen(QPen(Qt.black,  2, Qt.SolidLine))

        self.__painter.drawEllipse(QPoint(0,0), rd, rd)
        self.__painter.setPen(QPen(Qt.black,  2, Qt.DotLine))
        self.__painter.drawLine(0,-rd, 0, rd)
        self.__painter.drawLine(-rd,0, rd,0)
        self.__painter.restore()
    def __updatePieDirection(self):
        if self.__directions is None or len(self.__directions)==0:
            return
        for dirrection_item in self.__directions:
            angle,width,pen,brush=dirrection_item.allParametrs
            self.__draw_direction_pie(angle,width,pen,brush)
    def __draw_direction_pie(self,angle,width,pen=QPen(Qt.red,  2, Qt.DashLine),brush=QtGui.QBrush(QtGui.QColor(125, 0,0,),QtCore.Qt.FDiagPattern)):
        self.__painter.save()
        #self.__painter.translate(self.width()/2, self.height()/2)
        self.__painter.setPen(pen)
        #brush_q=QtGui.QBrush(QtGui.QColor(125, 0,0,),QtCore.Qt.FDiagPattern)
        self.__painter.setBrush(brush)
        rd=None
        if self.width()>self.height():
            rd=self.height()/2-self.point_otstup
        else:
            rd=self.width()/2-self.point_otstup
        #start_angle=angle+width/2

        start_angle=angle-width/2
        '''
        if end_angle<0:
            end_angle=360-end_angle
        
        if end_angle<start_angle:
            temp_angle=start_angle
            start_angle=end_angle
            end_angle=temp_angle
        '''
        istart_angle=start_angle*16
        iend_angle=width*16
        self.__painter.drawPie(self.point_otstup,2*self.point_otstup, 2*(rd), 2*(rd),istart_angle,iend_angle)
        self.__painter.restore()
    def __init_testDirection(self):
        self.__directions=[]
        dir_1=Direction(QPen(Qt.red,  2, Qt.DashLine),QtGui.QBrush(QtGui.QColor(255, 0,0,),QtCore.Qt.FDiagPattern))
        dir_1.setAngle(0)
        dir_1.setWidthDiagram(90)
        self.__directions.append(dir_1)
        dir_2=Direction(QPen(Qt.green,  2, Qt.DashLine),QtGui.QBrush(QtGui.QColor(0, 255,0,),QtCore.Qt.FDiagPattern))
        dir_2.setAngle(90)
        dir_2.setWidthDiagram(90)
        self.__directions.append(dir_2)



