import sys

from PySide2.QtGui import QPainter, QPalette, QPen, Qt
from PySide2.QtWidgets import QWidget, QApplication, QVBoxLayout, QFrame


class DirectionVario(QWidget):
    point_otstup=4
    def __init__(self, parent = None):
        super(DirectionVario, self).__init__(parent)
    def paintEvent(self, event):
        self.__painter = QPainter()
        self.__painter.begin(self)
        self.__painter.setRenderHint(QPainter.Antialiasing)
        self.__painter.fillRect(event.rect(), self.palette().brush(QPalette.Window))
        self.__draw_base()
        self.__draw_direction_pie(0,90)
        self.__painter.end()
    def __draw_base(self):

        self.__painter.save()
        print(str(self.width()/2)+"  "+str(self.height()/2))
        #self.__painter.translate(self.width()/2, self.height()/2)
        rd=None
        if self.width()>self.height():
            rd=self.height()/2-self.point_otstup
        else:
            rd=self.width()/2-self.point_otstup
        x=self.width()/2+self.point_otstup
        y=self.height()/2+self.point_otstup
        self.__painter.setPen(QPen(Qt.black,  2, Qt.SolidLine))

        self.__painter.drawEllipse(self.point_otstup,self.point_otstup, 2*rd, 2*rd)
        self.__painter.setPen(QPen(Qt.black,  2, Qt.DotLine))
        self.__painter.drawLine(self.point_otstup,self.height()/2, self.point_otstup+2*rd, self.height()/2)
        self.__painter.drawLine(self.point_otstup+rd,self.point_otstup, self.point_otstup+rd, self.height()/2+rd)
        self.__painter.restore()
    def __draw_direction_pie(self,angle,width):
        self.__painter.save()
        self.__painter.setPen(QPen(Qt.red,  8, Qt.DashLine))
        rd=None
        if self.width()>self.height():
            rd=self.height()/2-self.point_otstup
        else:
            rd=self.width()/2-self.point_otstup
        #start_angle=angle+width/2

        start_angle=angle-width/2
        '''
        if end_angle<0:
            end_angle=360-end_angle
        
        if end_angle<start_angle:
            temp_angle=start_angle
            start_angle=end_angle
            end_angle=temp_angle
        '''
        istart_angle=start_angle*16
        iend_angle=width*16
        self.__painter.drawPie(self.point_otstup,self.point_otstup, 2*rd, 2*rd,istart_angle,iend_angle)
        self.__painter.restore()
if __name__ == "__main__":
    app = QApplication(sys.argv)
    #window = QWidget()
    frame = QFrame()
    frame.resize(350,350)
    frame.setStyleSheet("background-color: rgb(200, 255, 255)")
    compass = DirectionVario()
    layout = QVBoxLayout()

    layout.addWidget(compass)

    frame.setLayout(layout)
    frame.setFixedWidth(320)
    frame.setFixedHeight(320)
    frame.show()
    sys.exit(app.exec_())
