import math
from concurrent.futures import ThreadPoolExecutor
from math import sqrt, radians, cos, sin, acos


def sumList(list_1,list_2):
    return [x+y  for x, y in zip(list_1, list_2)]
def sumListF(list_1,list_2):
    list_res=[0]*len(list_1)
    for i in range(len(list_1)):
        list_res[i]=list_1[i]+list_2[i]
    return list_res
def calcSimpleDist(x0,y0,x1,y1):
    dx=x1-x0
    dy=y1-y0
    dist=sqrt(dx*dx+dy*dy)
    return dist,dx,dy
class DirectionVario:
    ''' Направление расчета вариограммы'''
    def __init__(self,angle_direction,angle_smoth):
        self.__angle_direction=angle_direction
        self.__angle_smoth=angle_smoth
        self.__angle_dir=radians(angle_direction)
        self.__angle_smoth_rad=radians(angle_smoth)
        self.__cos_dir=cos( self.__angle_dir)
        self.__sin_dir=sin( self.__angle_dir)

        if angle_smoth>=89.9:
            self.__cos_angle_smoth =1.00
        else:
            self.__cos_angle_smoth=cos(self.__angle_smoth_rad)

        #self.__cos_angle_smoth=cos(self.__angle_smoth_rad)
        self.__max_index=0
    def setCount(self,count):
        self.__count=count
        self.__counts_par=[0]*count
        self.__list_d1=[0.0]*self.__count
        self.__list_d1=[0.0]*self.__count
    @property
    def head(self):
        str_head=str(self.__angle_direction)+"-"+str(self.__angle_smoth)
        return str_head
    @property
    def parmDirection(self):
        return self.__angle_direction,self.__angle_smoth
    def clone(self):
        clone_dir=DirectionVario(self.__angle_direction,self.__angle_smoth)
        clone_dir.setCount(self.__count)
        return clone_dir
    def isDirection(self,d_value,dx,dy,dist,index):
        '''
        проверяем попадает ли значение пары ( направление ) и накапливаем число пар и
        '''
        ''' используем теорему разницы cos углов
        cos(a−b)=cos(a)cos(b)+sin(a)sin(b)
        '''
        #cos(a) -  угол пар
        a_cos=dx/dist
        a_sin=dy/dist
        a_cos_a_b=a_cos*self.__cos_dir+a_sin*self.__sin_dir
        #angle_=acos(a_cos_a_b)
        #angle_grad=math.degrees(angle_)
        if abs(a_cos_a_b)>=self.__cos_angle_smoth:
            ''' направление между парами не попадает в данное направление и угол сглаживания'''
            return False
        self.__counts_par[index]=self.__counts_par[index]+1
        self.__list_d1[index]=self.__list_d1[index]+d_value*d_value
        if index>self.__max_index:
            self.__max_index=index
        return True
    @property
    def maxIndex(self):
        return self.__max_index
    @property
    def list_count_par(self):
        ''' Получаем число пар в интервалах '''
        return self.__counts_par
    @property
    def list_values(self):
        return self.__list_d1
    def sumArray(self,dir_var):
        ''' Получаем ( накапливаем ) значение пар в интервалах и значений'''
        if self.__max_index<dir_var.maxIndex:
            self.__max_index=dir_var.maxIndex
        self.__list_d1=sumList(self.__list_d1,dir_var.list_values)
        self.__counts_par=sumList(self.__counts_par,dir_var.list_count_par)
    def getResultVarioInDirection(self):
        count=self.__max_index+1
        result_array=[0.0]*count
        for i in range(count):
            if self.__counts_par[i]==0:
                result_array[i]=0
                continue
            result_array[i]=0.5*self.__list_d1[i]/float(self.__counts_par[i])
        return result_array
    @staticmethod
    def cloneArray(list_dirs):
        clon_array=[]
        for dir_angle in list_dirs:
            clon_array.append(dir_angle.clone())
        return clon_array
    @staticmethod
    def sumInDirectionVar(base_list_var,list_var):
        for i,var_dir_base in enumerate(base_list_var):
            var_dir_base.sumArray(list_var[i])

class CalcVarioqStep:
    def __init__(self,data_points,count,step):
        self.__data_points=data_points

        self.__count=count
        self.__step=step
        self.__end_id=len(self.__data_points)-1
        '''
        self.__list_direction=list_angle_direction
        if self.__list_direction is not None:
            for dir_var in self.__list_direction:
                dir_var.setCount(count)
        '''
    def build(self,obj_start,id_rec,list_angle_direction):
        count=0
        self.__sum_dist=0.0
        self.__list_d1=[0.0]*self.__count
        self.__list_d2=[0.0]*self.__count
        self.__list_count_par=[0]*self.__count
        sum_values=0.0
        sum_value_x2=0.0
        if id_rec==1:
            sum_values=sum_values +obj_start[2]
            sum_value_x2=sum_value_x2+obj_start[2]*obj_start[2]
        count_ds=1
        for i in range(id_rec,self.__end_id+1):
            ft=self.__data_points[i]
            if ft is None:
                continue
            count=count+1
            #geo=ft.GetGeometryRef()
            x=ft[0]
            y=ft[1]
            param_value=ft[2]
            if id_rec==1:
                sum_values=sum_values +ft[2]
                sum_value_x2=sum_value_x2+ft[2]*ft[2]
                count_ds=count_ds+1
            geo=None
            ft=None
            dist,dx,dy=calcSimpleDist(obj_start[0],obj_start[1],x,y)
            curent_index=int(dist/self.__step)
            '''
            self.__list_count_par[curent_index]=self.__list_count_par[curent_index]+1
            delta_parm=param_value-obj_start['param']
            self.__list_d1[curent_index]=self.__list_d1[curent_index]+delta_parm*delta_parm
            self.__sum_dist=self.__sum_dist+dist
            self.__midl_dist=self.__sum_dist/count
            '''
            for direction_var in list_angle_direction:
                isDir=direction_var.isDirection(param_value-obj_start[2],dx,dy,dist,curent_index)
                if isDir:
                    break
        if id_rec==1:
            self.__average=sum_values/(float(count_ds))
            self.__disp=sum_value_x2/(float(count_ds))-self.__average*self.__average
        return
    @property
    def disp(self):
        return self.__disp
    @property
    def listCount(self):
        return self.__list_count_par
    @property
    def listD1(self):
        return self.__list_d1
def BlockCalcVarioItemPool(data_points,cls_vario,list_start_id,all_count,list_direction_vario):
    if len(list_start_id)==0:
        return
    if len(list_start_id)==1:
        start_id = list_start_id[0]
        ft_base=data_points[start_id]
        obj_base=ft_base

        cls_vario.build(obj_base,start_id+1,list_direction_vario)
        return
    max_workers=len(list_start_id)
    with ThreadPoolExecutor(max_workers=max_workers) as e:
        for start_id in list_start_id:
            e.submit(cls_vario.build,data_points[start_id],start_id+1,list_direction_vario)


        '''
        tem_list_count=cls_vario.listCount
        tem_list_d1=cls_vario.listD1
        list_d1=sumList(list_d1,tem_list_d1)
        list_count=sumList(list_count,tem_list_count)
        '''
    return
def BlockCalcVarioItem(data_points,cls_vario,list_start_id,all_count,list_direction_vario):
    list_d1=[0.0]*all_count
    list_count=[0]*all_count
    for start_id in list_start_id:
        ft_base=data_points[start_id]
        #geo=ft_base.GetGeometryRef()
        #obj_base={"x":ft_base[0],"y":ft_base[1],"param":ft_base[1]}
        obj_base=ft_base
        #ft_base=None
        cls_vario.build(obj_base,start_id+1,list_direction_vario)
        '''
        tem_list_count=cls_vario.listCount
        tem_list_d1=cls_vario.listD1
        list_d1=sumList(list_d1,tem_list_d1)
        list_count=sumList(list_count,tem_list_count)
        '''
    return #list_count,list_d1
def simpleVariomgramBlock(data_points,dist_max,step,list_directionVario):

    count=len(data_points)


    all_count=int(dist_max/step+0.5)
    all_count=all_count+1
    for dir_var in list_directionVario:
        dir_var.setCount(all_count)
    cls_calc=CalcVarioqStep(data_points,all_count,step)
    list_d1=[0.0]*all_count
    list_count=[0]*all_count
    count_id=count
    size_block=8
    min_fid=0
    max_fid=count-1
    count_block=count_id // size_block
    if (count_id % size_block)>0:
        count_block=count_block+1
    ''' Цикл по блокам по size_block'''
    list_d1=[0.0]*all_count
    list_count=[0]*all_count
    for id_block in range(count_block):
        #print(str(id_block)+" from "+str(count_block))
        id_start=id_block*size_block+min_fid
        list_start_id=[]
        for i in range(size_block):
            cur_id=id_start+i
            if cur_id>max_fid:
                break
            list_start_id.append(cur_id)
        if len(list_start_id)==0:
            break
        clone_direction=DirectionVario.cloneArray(list_directionVario)
        #temp_counts,temp_var=BlockCalcVarioItem(data_points,cls_calc,list_start_id,all_count,clone_direction)
        BlockCalcVarioItem(data_points,cls_calc,list_start_id,all_count,clone_direction)
        DirectionVario.sumInDirectionVar(list_directionVario,clone_direction)
class VariogrammBuilder:
    def __init__(self):
        pass
    def setParametrs(self,data,directions,max_distance,step):
        self.__data_source=data
        self.__directions=directions
        self.__max_distance=max_distance
        self.__step=step
        self.__count=len(self.__data_source)
    @property
    def result(self):
        return self.__directions
    def pre_start(self):
        self.__all_count=int(self.__max_distance/self.__step+0.5)
        self.__all_count=self.__all_count+1
        for dir_var in self.__directions:
            dir_var.setCount(self.__all_count)
        self.__cls_calc=CalcVarioqStep(self.__data_source,self.__all_count,self.__step)

        count_id=len(self.__data_source)
        self.__size_block=8
        min_fid=0
        max_fid=self.__count-1
        self.__count_block=count_id // self.__size_block
        if (count_id % self.__size_block)>0:
            self.__count_block=self.__count_block+1
        return self.__count_block,self.__size_block
    def runBlock(self,id_block):
        min_fid=0
        max_fid=self.__count-1
        id_start=id_block*self.__size_block+min_fid
        list_start_id=[]
        for i in range(self.__size_block):
            cur_id=id_start+i
            if cur_id>max_fid:
                break
            list_start_id.append(cur_id)
        if len(list_start_id)==0:
            return
        clone_direction=DirectionVario.cloneArray(self.__directions)
        #temp_counts,temp_var=BlockCalcVarioItem(data_points,cls_calc,list_start_id,all_count,clone_direction)
        #BlockCalcVarioItemPool(self.__data_source,self.__cls_calc,list_start_id,self.__all_count,clone_direction)
        BlockCalcVarioItem(self.__data_source,self.__cls_calc,list_start_id,self.__all_count,clone_direction)
        DirectionVario.sumInDirectionVar(self.__directions,clone_direction)
        self.__dispersion=self.__cls_calc.disp
        return
    @property
    def dispersion(self):
        return self.__dispersion
    def run(self):
        all_count=int(self.__max_distance/self.__step+0.5)
        all_count=all_count+1
        for dir_var in self.__directions:
            dir_var.setCount(all_count)
        cls_calc=CalcVarioqStep(self.__data_source,all_count,self.__step)
        list_d1=[0.0]*all_count
        list_count=[0]*all_count
        count_id=len(self.__data_source)
        size_block=4
        min_fid=0
        max_fid=self.__count-1
        count_block=count_id // size_block
        if (count_id % size_block)>0:
            count_block=count_block+1
        ''' Цикл по блокам по size_block'''
        list_d1=[0.0]*all_count
        list_count=[0]*all_count
        for id_block in range(count_block):
            #print(str(id_block)+" from "+str(count_block))
            id_start=id_block*size_block+min_fid
            list_start_id=[]
            for i in range(size_block):
                cur_id=id_start+i
                if cur_id>max_fid:
                    break
                list_start_id.append(cur_id)
            if len(list_start_id)==0:
                break
            clone_direction=DirectionVario.cloneArray(self.__directions)
            #temp_counts,temp_var=BlockCalcVarioItem(data_points,cls_calc,list_start_id,all_count,clone_direction)
            BlockCalcVarioItem(self.__data_source,cls_calc,list_start_id,all_count,clone_direction)
            DirectionVario.sumInDirectionVar(self.__directions,clone_direction)

