import axipy
from axipy import Polygon




from RasterGridTool.toolprocessing.grid_io.GdalSource import RasterSource


def getBound(table):
    cs=table.coordsystem
    size=table.size
    transform=table.device_to_scene_transform
    x0,y0=transform.map(0,0)
    x1,y1=transform.map(0,size.height())
    x2,y2=transform.map(size.width(),size.height())
    x3,y3=transform.map(size.width(),0)
    bound=Polygon([(x0,y0),(x1,y1),(x2,y2),(x3,y3)],cs)
    return bound
class AxiRaster:
    def __init__(self,tab_raster):
        self.__axi_raster=tab_raster
        self.__prepareInfo()
    def __prepareInfo(self):
        self.__color_table=None
        self.__actualBand=None
        self.__bound_poly=getBound(self.__axi_raster)
        self.__path_raster=self.__axi_raster.properties['fileName']
        self.__raster_grid= RasterSource()
        self.__raster_grid.OpenRead(self.__path_raster)
        self.__isGrid=self.__raster_grid.isGrid
        self.__isVrt=self.__raster_grid.IsVrt
        #self.__color_table=self.__raster_grid.colorTable
        if self.__isGrid:
            self.__actualBand=self.__raster_grid.getIdBand
        self.__raster_grid.close()
    @property
    def rasterSource(self):
        return self.__raster_grid

    @property
    def isVrt(self):
        return self.__isVrt
    @property
    def name(self):
        self.__axi_raster.name
    @property
    def IsGrid(self):
        return self.__isGrid
    @property
    def coordsystem(self):
        return self.__axi_raster.coordsystem
    @property
    def bound(self):
        return self.__bound_poly
    @property
    def pathRaster(self):
        return self.__path_raster
    @property
    def IdBand(self):
        return self.__actualBand
def getClassAxiGrid(name_raster,name_observer='GridAxi'):
    axiGrid=axipy.ObserverManager.get(name_observer)
    if axiGrid is None:
        return None
    list_grid = axiGrid.value
    axiGrid = list_grid[name_raster]
    return axiGrid
